      SUBROUTINE RCA01
C
C        RCA01 IS THE INITILIZATION ROUTINE
C
      CHARACTER   TITLE*80,TYPE*15
      INTEGER*2  SYSGDP(40)
      INCLUDE  'RCACM'
C        INITIAL -SYSBY- SETTINGS
      DATA  SYSGDP/40*1/
 
C        DEFINE I/O DEVICES
      IN = 5
      OUT = 6
 
C        THE -LIST- ARRAY CONTROLS THE LISTING OF THE USERS INPUT DECK
C         LIST(#)        CONTROLS THE LISTING OF
C              1   GEOMETRY...EXCHANGES, VOLUMES AND FLOWS
C              2   BOUNDARY CONDITIONS
C              3   LOADINGS
C              4   PARAMETERS, CONSTANTS AND MISC TIME FNS
C              5   INITIAL CONDITIONS
C        LIST = 0   LIST INPUT
C        LIST = 1   DO NOT LIST INPUT
C
      READ(IN,1000,ERR=950)   CYCLE,MODEL,ISER,IRUN,LIST,IDIAGDT
 1000 FORMAT(10I5)
      WRITE(OUT,1500)
 1500 FORMAT( 1H1/////1X,120('*')/1X,120('*')////
     .   25X,'R C A 3 D   - -  R O W / C O L U M N   A E S O P'/
     .   25X,'                  ( 3 - D I M E N S I O N A L )'//
     .   96X,'VERSION 2.0'/70X,'DEVELOPED BY HYDROQUAL INC.  MAHWAH, NJ'
     .  ///)
      WRITE(OUT,2000)   MODEL,ISER,IRUN
 2000 FORMAT(    /////1X,120('*')/1X,120('*')/////5X,'MODEL ',I3,
     .     ' SERIES ',I3,' RUN ',I3//)
      IF(CYCLE.EQ.0)  THEN
         WRITE(OUT,1600)
 1600    FORMAT(
     .     15X,'INITIAL CONDITIONS WILL BE READ FROM USER INPUT DECK'//)
      ELSE
         WRITE(OUT,1601)
 1601    FORMAT(
     .     15X,'INITIAL CONDITIONS WILL BE READ FROM RCAFIC'//)
      ENDIF

   10 READ (IN,1100) TITLE
 1100 FORMAT(A)
      IF(TITLE(1:3).NE.'END' .AND. TITLE(1:3).NE.'end')   THEN
         WRITE(OUT,1110)   TITLE
 1110    FORMAT(10X,A80)
         GO TO 10
      ENDIF
      WRITE(OUT,2100)
 2100 FORMAT(    /////1X,120('*')/1X,120('*')/////)

C        READ STATE VARIABLE NAMES
      READ(IN,1120,ERR=950)  (SYNAME(I),I=1,NOSYS)
 1120 FORMAT(10A8)
      WRITE(OUT,2250)  (I,SYNAME(I),I=1,NOSYS)
 2250 FORMAT(5X,'THE FOLLOWING STATE-VARIABLES ARE BEING MODELED'/ 20X,
     .   'SYSTEM     VARIABLE'/20X,6('-'),5X,8('-')/(20X,I4,'.',6X,A8))

      READ(IN,1100,ERR=950)   TYPE
      IF(TYPE(1:4).EQ.'TIME')   THEN
         ISIM = 0
         WRITE(OUT,2600)
 2600    FORMAT(//15X,'TIME VARIABLE SIMULATION REQUESTED'//)
      ELSE IF(TYPE(1:4).EQ.'STEA')   THEN
         ISIM = 1
         WRITE(OUT,2700)
 2700    FORMAT(//15X,'STEADY STATE SIMULATION REQUESTED'//)
      ELSE
         WRITE(OUT,2500)
 2500    FORMAT(
     .      15X,'USER FAILED TO SPECIFY SOLUTION TYPE --- STEADY STATE '
     .     ,'-OR- TIME VARIABLE'/45X,'PROGRAM TERMINATED')
         CALL EXIT
      ENDIF

      READ(IN,3000,ERR=950)   (SYSBY(I),I=1,NOSYS)
 3000 FORMAT(25I2)
      WRITE(OUT,4000)    NOSYS,(SYSBY(I),I=1,NOSYS)
 4000 FORMAT(20X,'SYSTEM BYPASS OPTIONS FOR SYSTEMS 1 TO',I3,' ARE',
     .  25I2)

C        DETERMINE SYSTEM NUMBER OF LAST ACTIVE SYSTEM
      DO 20 ISYS=1,NOSYS
        SYSGDP(ISYS) = SYSBY(ISYS)
        IF(SYSBY(ISYS).EQ.0)   MXACTS = ISYS
   20 CONTINUE

      WRITE(10)   NROW,NCOL,NLAYR,NOSYS
      WRITE(10)   SYNAME
      WRITE(10)   SYSGDP
      WRITE(OUT,4500)
 4500 FORMAT(/////1X,119('*')/1X,119('*')/1H1)

C        OTHER INITIALIZATION
      INITB = 0
      IREC=0

      DO 40 ISYS=1,NOSYS
        DO 30 IL=1,NLAYR
        DO 30 IC=1,NCOL
        DO 30 IR=1,NROW
          CDARAY(IR,IC,IL,ISYS) = 0.
          CARAY(IR,IC,IL,ISYS) = 0.
   30   CONTINUE
        DO 35 I=1,NBC
          SBC(I,ISYS) = 0.
   35   CONTINUE
   40 CONTINUE

      DO 60 IL=1,NLAYR+1
      DO 60 IC=1,NCOL
      DO 60 IR=1,NROW
        IF(IL.LE.NLAYR)  THEN
          VDER(IR,IC,IL) = 0.
          QX(IR,IC,IL) = 0.
          QY(IR,IC,IL) = 0.
          RX(IR,IC,IL) = 0.
          RY(IR,IC,IL) = 0.
        ENDIF
        QZ(IR,IC,IL) = 0.
        RZ(IR,IC,IL) = 0.
   60 CONTINUE

      RETURN

 950  CALL FMTER
      CALL EXIT
      END
