      SUBROUTINE RCA02
C 
C        RCA02 READS PRINT CONTROL PARAMETERS AND INTEGR HISTORY
C 
      INCLUDE  'RCACM'
      INTEGER*2  DDGDPBY(40)
      DATA  DDGDPBY/40*1/

      WRITE(OUT,8000) 
 8000 FORMAT(/////1X,119('*')//)

      READ(IN,1000,ERR=950) PRNTG,PRNTD,NDMPS
 1000 FORMAT(2F10.3,I5) 
      IF(NDMPS.GT.0)   THEN
         OPEN(12,FILE='RCAF12',FORM='UNFORMATTED')
         OPEN(13,FILE='RCAF13',FORM='UNFORMATTED')
         READ(IN,1100)  ((IFDMPS(I,J),J=1,3),I=1,NDMPS)
 1100    FORMAT(18I4)
         READ(IN,1150)  (DDMPSBY(ISYS),ISYS=1,NOSYS)
 1150    FORMAT(40I2)
         DO 10 ISYS=1,NOSYS
           DDGDPBY(ISYS) = DDMPSBY(ISYS)
   10    CONTINUE
         WRITE(12)  NDMPS
         WRITE(12)  ((IFDMPS(I,J),J=1,3),I=1,NDMPS)
         WRITE(12)  DDGDPBY
      ENDIF
 
      IF(ISIM.EQ.0)  THEN
         IF(PRNTG.LT.1.0)   WRITE(OUT,1200)   PRNTG
 1200    FORMAT(/5X,'GLOBAL PRINT INTERVAL',F10.4/)
         IF(PRNTG.GE.1.0)   WRITE(OUT,1210)   PRNTG
 1210    FORMAT(/5X,'GLOBAL PRINT INTERVAL',F10.4/)
         IF(NDMPS.GT.0)  THEN
            IF(PRNTD.LT.1.0)   WRITE(OUT,1220)   PRNTD
            IF(PRNTD.GE.1.0)   WRITE(OUT,1230)   PRNTD
            WRITE(OUT,1235)    ((IFDMPS(I,J),J=1,3),I=1,NDMPS)
         ENDIF
 1220    FORMAT(/5X,'THE FOLLOWING SEGMENTS WILL BE SAVED USING A PRINT 
     .INTERVAL OF',F10.4/)
 1230    FORMAT(/5X,'THE FOLLOWING SEGMENTS WILL BE SAVED USING A PRINT 
     .INTERVAL OF',F10.1/)
 1235    FORMAT(10X,7('(',2I4,I3,')'),2X)
      ELSE
         WRITE(OUT,1300)   PRNTG
 1300    FORMAT(/5X,'PRINT INTERVAL, EVERY',F5.0,' ITERATIONS'/) 
      ENDIF

      READ(IN,1100,ERR=950)    ((IDUMP(I,J),J=1,3),I=1,6) 

      IF(ISIM.EQ.1)   GO TO 100 
  
C        INTGRTYP -  INTEGRATION METHOD
C                     = 0  -  IMPLICIT - UPWIND
C                     = 1  -  EXPLICIT - UPWIND
C                     = 2  -  LEAPFROG - CENTRAL
C                     = 3  -  SPLIT TIME STEP - UPWIND
C                     = 4  -  EXPLICIT - UPWIND/SMOLARKIEWICZ
C                     = 5  -  LEAPFROG - UPWIND/SMOLARKIEWICZ
C                     = 6  -  SPLIT TIME STEP - UPWIND/SMOLARKIEWICZ
C         NEGSLN   =  0  POSITIVE SOLUTIONS ONLY
C                     1  NEGATIVE SOLUTIONS PERMITTED
C         ISMOLAR  =  0  "ECOM3D" SMOLAR_2
C                     1  "ECOM3D" SMOLAR_R

      READ(IN,2000,ERR=950) INTGRTYP,NEGSLN,ISMOLAR
 2000 FORMAT(3I5) 
      IF(INTGRTYP.EQ.0)    WRITE(OUT,2020) 
 2020 FORMAT(/////10X,'IMPLICIT INTEGRATION SELECTED')
      IF(INTGRTYP.EQ.1)    WRITE(OUT,2030) 
 2030 FORMAT(/////10X,'EXPLICIT INTEGRATION SELECTED')
      IF(INTGRTYP.EQ.2)    WRITE(OUT,2040) 
 2040 FORMAT(/////10X,'LEAPFROG INTEGRATION SELECTED')
      IF(INTGRTYP.EQ.3)    WRITE(OUT,2050) 
 2050 FORMAT(/////10X,'SPLIT TIMESTEP INTEGRATION SELECTED')
      IF(INTGRTYP.GE.4)    WRITE(OUT,2060) 
 2060 FORMAT(/////10X,'SMOLARKIEWICZ CORRECTION SELECTED')

      IF(NEGSLN.EQ.1)   WRITE(OUT,2070) 
 2070 FORMAT(5X,'USER HAS CHOSEN TO PERMIT NEGATIVE SOLUTIONS'/)

      READ(IN,2200,ERR=950)  SCALT,TZERO,DTWQ
 2200 FORMAT(8E10.4)
      WRITE(OUT,2150)   SCALT 
 2150 FORMAT(10X,'TIME WARP FACTOR',E16.6/) 
      IF(TZERO.NE.0.)   WRITE(OUT,2175)   TZERO 
 2175 FORMAT(10X,'TIME =',F7.2,' IS THE START OF THE SIMULATION'/)
      IF(DTWQ.NE.0.)   WRITE(OUT,2180)   DTWQ
 2180 FORMAT(
     .  10X,'INTEGRATION STEP-SIZE TO BE USED FOR THE KINETIC SUBROUTINE
     . -TUNER- IS',F7.3)
 
      IF(INTGRTYP.EQ.3 .OR. INTGRTYP.EQ.6)  THEN
         READ(IN,2200,ERR=950)  DTSPLIT,DTFULL,TEND
         DT = DTFULL
         NSTEP = 1
         WRITE(OUT,2505)  DTSPLIT,DTFULL,TEND
 2505    FORMAT(10X,'SPLIT TIMESTEP INTEGRATION'/
     .     10X,'DTSPLIT =',F6.4,' DTFULL =',F6.4,' TEND =',F6.1)
      ELSE
         READ (IN,2100,ERR=950)NSTEP
 2100    FORMAT (I5)
         READ(IN,2200,ERR=950) (STEP(I),TBRK(I),I=1,NSTEP)
         TEND = TBRK(1)
         DT = STEP(1)
         WRITE(OUT,2350) 
 2350    FORMAT(1X,4(5X,'DT',9X,'T',5X)/)
         WRITE(OUT,2500) (STEP(I),TBRK(I),I=1,NSTEP)
 2500    FORMAT(4(F10.5,F12.5))
      ENDIF
      WRITE(OUT,2510) 
 2510 FORMAT(/////) 

      IF(DT.EQ.0.0)   THEN
         WRITE(OUT,2310)
 2310    FORMAT(///5X,'ERROR...INTEGRATION STEP SIZE = 0.0')
         CALL EXIT
      ENDIF

      RETURN

C        STEADY-STATE SOLUTION INFORMATION
  100 READ(IN,2600,ERR=950)   OMEGA,NEGSLN
 2600 FORMAT(F10.0,I5)
      WRITE(OUT,2800)   OMEGA 
 2800 FORMAT(10X,'OMEGA =',F5.2//)
      READ(IN,1200,ERR=950)  TZERO
      WRITE(OUT,2900)   TZERO 
 2900 FORMAT(10X,'TIME FOR WHICH SOLUTION DESIRED',F6.1/) 
      READ(IN,3000,ERR=950)   ITCHCK,MXITER 
 3000 FORMAT(2I5) 
      WRITE(OUT,3100)   ITCHCK,MXITER 
 3100 FORMAT(10X,'SOLUTION CHECKED EVERY',I6,' ITERATIONS'/ 
     .       10X,'MAXIMUM NUMBER OF ITERATIONS ALLOWED EQUALS',I6/////) 

      RETURN

  950 CALL FMTER
      CALL EXIT 
      END 
