       SUBROUTINE RCA03
C 
C        RCA03 READS THE MODEL GEOMETRY AND INITIAL TRANSPORT FIELDS
C              AS PROVIDED BY THE HYDRODYNAMIC MODEL
C 
      INCLUDE   'RCACM' 
      INTEGER    IMINROW(20),IMINCOL(20),IMINLAYR(20),TOTLWATR
      REAL
     .     TPS(NROW,NCOL),MINDT(20),SCRATCH(NROW*NCOL*NLAYR)
     .   , TIMESTEP(NROW,NCOL,NLAYR),TIMESTEPS(NROW*NCOL*NLAYR)
     .   , CAP

C
      EQUIVALENCE
     .     (TPS(1,1),EZ(1,1,1)) , (SCRATCH(1),TIMESTEP(1,1,1))
     .   , (TIMESTEP(1,1,1),SCRATCH_TRAN(1,1,1,1))

      DATA   MINDT/20*100./ , TOTLWATR/0/

      WRITE(OUT,8000) 
 8000 FORMAT(/////1X,119('*')//)
  
      READ(IN,1100)  NOHYD,ICOLLOPT,HYDCYCOPT,LNDWTROPT
 1100 FORMAT(4I5)
      IF(NOHYD.GT.NHYD)  GO TO 960
      IF(ICOLLOPT.EQ.1)  WRITE(OUT,1102)
 1102 FORMAT(33X,'RCA IS BEING RUN USING A COLLAPSED VERSION OF THE HYDR
     .ODYNAMIC MODEL'/)
      IF(HYDCYCOPT.EQ.1)  WRITE(OUT,1103)
 1103 FORMAT(37X,'HYDRODYNAMIC FILE WILL BE CYCLED IF END-OF-FILE ENCOUN
     .TERED'/)
      IF(LNDWTROPT.EQ.1)  WRITE(OUT,1104)
 1104 FORMAT(35X,'WATER SEGMENTS ONLY READ OPTION SELECTED FOR HYDRODYNA
     .MIC INPUT'/)
      READ(IN,1105)  (HYDBRK(I),I=1,8)
 1105 FORMAT(8F10.0)
      IF(HYDBRK(8).GT.0.)  THEN
        READ(IN,1105)  (HYDBRK(I),I=9,NOHYD)
      ELSE
        DELTA = HYDBRK(3) - HYDBRK(2)
        DO 5 I=3,NOHYD
          HYDBRK(I) = HYDBRK(2) + DELTA*FLOAT(I-2)
    5   CONTINUE
      ENDIF
c     WRITE(OUT,1110)  (HYDBRK(I),I=1,NOHYD)
      WRITE(OUT,1110)  (HYDBRK(I),I=1,8)
 1110 FORMAT(40X,'TIME BREAKS (DAYS) FOR THE HYDRODYNAMIC INPUTS ARE AT'
     .  /(26X,8F10.2))
      NXHYDT = HYDBRK(2)
      ITIMHYD = 2
  
      READ(IN,1200)  SCALQ,SCALRX,SCALRY,SCALRZ
 1200 FORMAT(4F10.0)

      WRITE(OUT,1210)  SCALQ,SCALRX,SCALRY,SCALRZ
 1210 FORMAT(///
     .  40X,' ADVECTIVE SCALE FACTOR =  ',E11.3/
     .  40X,'X-DISPERSION SCALE FACTOR =',E11.3/
     .  40X,'Y-DISPERSION SCALE FACTOR =',E11.3/
     .  40X,'Z-DISPERSION SCALE FACTOR =',E11.3)


      OPEN(20,FILE='gcm_geom',FORM='UNFORMATTED')
      READ(20)  DZ,DZZ
      READ(20)  H,DX,DY,FSM
      IF(ICOLLOPT.EQ.1)READ(20)  XAZ
      CLOSE(20)

C        GENERATE -ZZ- ARRAY
      ZZ(1) = DZ(1)/2.
      DO  10 IL=2,NLAYR
        ZZ(IL) = ZZ(IL-1) + DZZ(IL-1)
   10 CONTINUE

C        WRITE LAND-MASK ARRAY FOR USE IN GDP
      WRITE(10)   FSM

C        FIND MIN-MAX WATER SEGMENTS FOR EACH ROW

      DO 20 IC=1,NCOL
       IRS(IC) = 0
       DO 15 IR=1,NROW
        IF(FSM(IR,IC).EQ.1.)  THEN
          TOTLWATR = TOTLWATR+1
          IF(IRS(IC).EQ.0)  IRS(IC) = IR 
          IRE(IC) = IR
        ENDIF
   15  CONTINUE
   20 CONTINUE
      TOTLWATR = NLAYR*TOTLWATR
         
C        IF WATER SEGMENTS ONLY READ OPTION SELECTED THEN GET
C        LOCATIONS OF THE 'WET' GRID
      IF(LNDWTROPT.EQ.1)  THEN
        OPEN(20,FILE='wet_grid',FORM='UNFORMATTED')
        READ(20)  IWTRCNT
        DO 25 I=1,IWTRCNT
          READ(20)  IWTRNDX(I),JWTRNDX(I)
   25   CONTINUE
      ENDIF

      READ(IN,1300)   HYDFILNA
 1300 FORMAT(A40)
      WRITE(OUT,1310)  HYDFILNA
 1310 FORMAT(//20X,'OPENING HYDRODYNAMIC TRANPORT FIELD FILE =',A40)
      OPEN(20,FILE=HYDFILNA,FORM='UNFORMATTED',STATUS='OLD',ERR=900)

      icount=0
      ENTRY   RCA03A

   30 READ(20,END=920)  TMID
      icount=icount+1
      if(icount.eq.1)TMID0=TMID
      WRITE(OUT,8010)   TIME,TMID
 8010 FORMAT(' Hydrodynamic Update at Time =',2F9.4)


      IF(LNDWTROPT.EQ.0)  THEN
C        READ FULL LAND/WATER GRID
        READ(20)  QX
        READ(20)  QY
        IF (NLAYR.GT.1) READ(20)  QZ
        READ(20)  EX
        READ(20)  EY
        IF (NLAYR.GT.1) READ(20)  EZ
        READ(20)  ETA
        READ(20)  DETA
        READ(20)  HYDSAL
        READ(20)  HYDTEMP

      ELSE

C        READ WATER ONLY GRID AND PUT INTO FULL GRID
        CALL LNDWTR(QX,SCRATCH,IWTRCNT,NLAYR)
        CALL LNDWTR(QY,SCRATCH,IWTRCNT,NLAYR)
        IF (NLAYR.GT.1)  CALL LNDWTR(QZ,SCRATCH,IWTRCNT,NLAYR)
C    CHECK IF UNCOLLAPSED/COLLAPSED READ
        IF(ICOLLOPT.EQ.0)  THEN
          CALL LNDWTR(EX,SCRATCH,IWTRCNT,NLAYR)
          CALL LNDWTR(EY,SCRATCH,IWTRCNT,NLAYR)
          IF (NLAYR.GT.1)  CALL LNDWTR(EZ,SCRATCH,IWTRCNT,NLAYR)
          CALL LNDWTR(ETA,SCRATCH,IWTRCNT,1)
          CALL LNDWTR(DETA,SCRATCH,IWTRCNT,1)
        ELSE
          CALL LNDWTR(RX,SCRATCH,IWTRCNT,NLAYR)
          CALL LNDWTR(RY,SCRATCH,IWTRCNT,NLAYR)
          IF (NLAYR.GT.1)  CALL LNDWTR(RZ,SCRATCH,IWTRCNT,NLAYR)
          CALL LNDWTR(HBAR,SCRATCH,IWTRCNT,1)
          CALL LNDWTR(BVOL,SCRATCH,IWTRCNT,NLAYR)
          CALL LNDWTR(VDER,SCRATCH,IWTRCNT,NLAYR)
        ENDIF
        CALL LNDWTR(HYDSAL,SCRATCH,IWTRCNT,NLAYR)
        CALL LNDWTR(HYDTEMP,SCRATCH,IWTRCNT,NLAYR)

Cjrb    Ensure positive temperatures, code from jamaica bay
        do il=1,nlayr
         do ic=1,ncol
          do ir=1,nrow
           if(fsm(ir,ic).eq.1) then
             if(HYDTEMP(ir,ic,il).lt.0.)  HYDTEMP(ir,ic,il)=0.1
           endif
          enddo
         enddo
        enddo

      ENDIF

C        IF UNCOLLAPSED GRID COMPUTE SEGMENT VOLUMES  (M^3)

      IF(ICOLLOPT.EQ.0)  THEN
        DO 40 IL=1,NLAYR
        DO 40 IC=1,NCOL
        DO 40 IR=1,NROW
          BVOL(IR,IC,IL) = DX(IR,IC)*DY(IR,IC)*(H(IR,IC)+ETA(IR,IC))*
     .                   DZ(IL)+1.0E-20
   40   CONTINUE
      ENDIF

      IF(LIST(1).EQ.0)  THEN
         WRITE(OUT,1000)
 1000    FORMAT(/49X,'SEGMENT VOLUMES (M^3)'//)
         CALL RCAPRNT(BVOL,1,NLAYR)
      ENDIF

C        IF UNCOLLAPSED GRID COMPUTE SURFACE AREAS AND
C        CROSS SECTIONAL AREAS

      IF(ICOLLOPT.EQ.0)  THEN
        DO 65 IC=1,NCOL
        DO 65 IR=1,NROW
          XAZ(IR,IC) = DX(IR,IC)*DY(IR,IC)
   65   CONTINUE

        DELTHYD = SCALT*(HYDBRK(ITIMHYD)-HYDBRK(ITIMHYD-1))/2.

        DO 70 IL=1,NLAYR
        DO 70 IC=2,NCOL
        DO 70 IR=2,NROW

        IF(FSM(IR,IC).GE.1. OR. FSM(IR,IC).LE.-2)THEN
          IF(FSM(IR-1,IC).GE.1. OR. FSM(IR-1,IC).LE.-2)THEN
            AVEH = (H(IR-1,IC)+ETA(IR-1,IC)+DELTHYD*DETA(IR-1,IC)*86400.
     .           + H(IR,IC)+ETA(IR,IC)+DELTHYD*DETA(IR,IC)*86400.)/2.
            XAX(IR,IC,IL) = AVEH*DZ(IL)*(DY(IR-1,IC)+DY(IR,IC))/2.
          ENDIF

          IF(FSM(IR,IC-1).GE.1. OR. FSM(IR,IC-1).LE.-2)THEN
            AVEH = (H(IR,IC-1)+ETA(IR,IC-1)+DELTHYD*DETA(IR,IC-1)*86400.
     .           + H(IR,IC)+ETA(IR,IC)+DELTHYD*DETA(IR,IC)*86400.)/2.
            XAY(IR,IC,IL) = AVEH*DZ(IL)*(DX(IR,IC-1)+DX(IR,IC))/2.
          ENDIF
        ENDIF

   70   CONTINUE

C        COMPUTE AVERAGE DEPTHS FOR THE TIME-INTERVAL

        DO 75 IC=1,NCOL
        DO 75 IR=1,NROW
          HBAR(IR,IC) = H(IR,IC)+ETA(IR,IC)+DELTHYD*DETA(IR,IC)*86400.
   75   CONTINUE
      ENDIF
     
C        SCALE ADVECTIVE FIELDS

      DO 80 IL=1,NLAYR
      DO 80 IC=1,NCOL
      DO 80 IR=1,NROW
        QX(IR,IC,IL) = SCALQ*QX(IR,IC,IL)
        QY(IR,IC,IL) = SCALQ*QY(IR,IC,IL)
        QZ(IR,IC,IL) = SCALQ*QZ(IR,IC,IL)
   80 CONTINUE
     
C        COMPUTE ADVECTIVE AND DISPERSIVE FIELDS
C
      IF (NLAYR.EQ.1) THEN
        DO 85 IC=1,NCOL
        DO 85 IR=1,NROW
            TPS(IR,IC)=SQRT(DX(IR,IC)*DX(IR,IC)+DY(IR,IC)*DY(IR,IC))
 85     CONTINUE
C
        FMIN=1.E20
        DO 86 IC=1,NCOL
        DO 86 IR=1,NROW
            FMIN=AMIN1(FMIN,TPS(IR,IC))
 86     CONTINUE
      ENDIF

      IF(ICOLLOPT.EQ.0)  THEN
      DO 90 IL=1,NLAYR
      DO 90 IC=2,NCOL
      DO 90 IR=2,NROW
 
        IF(FSM(IR,IC).GE.1. OR. FSM(IR,IC).LE.-2)THEN
          IF (NLAYR.EQ.1) THEN
            IF(FSM(IR-1,IC).GE.1. OR. FSM(IR-1,IC).LE.-2)THEN
              EX(IR,IC,IL)=1.0*FSM(IR,IC)*FSM(IR-1,IC)*TPS(IR,IC)/FMIN
            ENDIF
            IF(FSM(IR,IC-1).GE.1. OR. FSM(IR,IC-1).LE.-2)THEN
              EY(IR,IC,IL)=1.0*FSM(IR,IC)*FSM(IR,IC-1)*TPS(IR,IC)/FMIN
            ENDIF
          ENDIF
 
          IF(FSM(IR-1,IC).GE.1. OR. FSM(IR-1,IC).LE.-2)THEN
            RX(IR,IC,IL) = SCALRX*EX(IR,IC,IL)*XAX(IR,IC,IL)
     .                    /(0.5*(DX(IR-1,IC)+DX(IR,IC)))
          ENDIF

          IF(FSM(IR,IC-1).GE.1. OR. FSM(IR,IC-1).LE.-2)THEN
            RY(IR,IC,IL) = SCALRY*EY(IR,IC,IL)*XAY(IR,IC,IL)
     .                    /(0.5*(DY(IR,IC-1)+DY(IR,IC)))
          ENDIF
        ENDIF

        IF(IL.GT.1.AND.NLAYR.GT.1.AND.FSM(IR,IC).GE.1) THEN
           RZ(IR,IC,IL) = SCALRZ*EZ(IR,IC,IL)*XAZ(IR,IC)
     .                    /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(IR,IC))
        ENDIF
   90 CONTINUE

C        COMPUTE VOLUME DERIVATIVE
C        (M^3/SEC * 86400. ==> M^3/DAY)

      DO 100 IL=1,NLAYR
      DO 100 IC=1,NCOL
      DO 100 IR=1,NROW
        VDER(IR,IC,IL) = 86400.*DZ(IL)*DETA(IR,IC)*XAZ(IR,IC)
  100 CONTINUE
      ENDIF

C        SCALE ADVECTIVE FIELDS

      IF(ICOLLOPT.EQ.1)  THEN
      DO 105 IL=1,NLAYR
      DO 105 IC=1,NCOL
      DO 105 IR=1,NROW
        RX(IR,IC,IL) = SCALRX*RX(IR,IC,IL)
        RY(IR,IC,IL) = SCALRY*RY(IR,IC,IL)
        RZ(IR,IC,IL) = SCALRZ*RZ(IR,IC,IL)
  105 CONTINUE
      ENDIF
     
Cbw   092796 FOR RUN 15-3 DECREASE VERT E FOR THROGS NECK OUT LIS
C     LIS FROM THROGS NECK MIX LESS FOR MORE STRAT DURING SUMMER JJA
C      in order to match HEM's trick, 3 spots
        IF (TIME.GT.240.AND.TIME.LE.330) THEN
           DO IL=1,10
           DO IR=36,44
           DO IC=46,64
              RZ(IR,IC,IL) = 0.01*RZ(IR,IC,IL)
           ENDDO
           ENDDO
           ENDDO
        ENDIF
Crlmrun48 For this region for July only go for 0.001
C *0.01 above + *0.1 here
        IF (TIME.GT.273.AND.TIME.LE.304) THEN
           DO IL=1,10
           DO IR=36,44
           DO IC=46,64
              RZ(IR,IC,IL) = 0.1*RZ(IR,IC,IL)
           ENDDO
           ENDDO
           ENDDO
        ENDIF

        IF (TIME.GT.240.AND.TIME.LE.330) THEN
           DO IL=1,10
           DO IR=26,35
           DO IC=56,59
              RZ(IR,IC,IL) = 0.01*RZ(IR,IC,IL)
           ENDDO
           ENDDO
           ENDDO
        ENDIF
C     
C          reduce RZ from mile 0 up (whole east river)
C          increase RZ from mile 0 up (whole east river)
C9495-59don't do anything to lower East River
        IF (TIME.GT.240.AND.TIME.LE.330) THEN
           DO IL=1,10
           DO IR=22,25
           DO IC=48,57
C             RZ(IR,IC,IL) = 0.01*RZ(IR,IC,IL)
C             RZ(IR,IC,IL) = 10.0*RZ(IR,IC,IL)
           ENDDO
           ENDDO
           ENDDO
        ENDIF
Crlm include vert E adj for July+August betweem mp 52 and 80
        IF (TIME.GT.273.AND.TIME.LE.335) THEN
           DO IL=1,10
           DO IR=37,44
           DO IC=41,45
              RZ(IR,IC,IL) = 0.01*RZ(IR,IC,IL)
           ENDDO
           ENDDO
           ENDDO
        ENDIF
C     
C       CAP ON RZ ER MP 14 to 16
C        DO IT FOR JULY AND AUGUST
        IF (TIME.GT.273.AND.TIME.LE.335) THEN
          DO IL=1,10
          DO IR=33,37
          DO IC=56,59
        CAP=RZ(IR,IC,IL)*(0.5*(DZ(IL)+DZ(IL-1))*HBAR(IR,IC))/XAZ(IR,IC)
         IF(CAP.GT.(1.0/86400.)) THEN
              RZ(IR,IC,IL) = (1.0/86400.)*XAZ(IR,IC)
     .                        /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(IR,IC))
         ENDIF
           ENDDO
           ENDDO
           ENDDO
        ENDIF
Cbw   end reducing RZ
C9495-55 MIX BIGHT near NJ coast less for August survey
        IF (TIME.GT.310.AND.TIME.LE.330) THEN
           DO IL=1,10
           DO IR=18,20
           DO IC=2,26
              RZ(IR,IC,IL) = 0.001*RZ(IR,IC,IL)
           ENDDO
           ENDDO
           ENDDO
        ENDIF
C9495-66 MIX UPPER HUDSON MORE for JULY thru SEPTEMBER
        IF (TIME.GT.273) THEN
           DO IL=1,10
           DO IC=78,83
              RZ(10,IC,IL) = 100.0*RZ(10,IC,IL)
           ENDDO
           ENDDO
           DO IL=1,10
           DO IR=11,19
              RZ(IR,83,IL) = 100.0*RZ(IR,83,IL)
           ENDDO
              RZ(19,82,IL) = 100.0*RZ(19,82,IL)
           ENDDO
        ENDIF
Cjrw RUN043 1/16/02 put back Newark Bay
      IF(TIME.GT.243.AND.TIME.LE.365) THEN
        DO IL=1,10
          DO IC=41,61
            IF(EZ(8,IC,IL).LT.0.0005) THEN
              RZ(8,IC,IL) = SCALRZ*0.0005*XAZ(8,IC)
     .                       /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(8,IC))
            END IF
          END DO
          IF(EZ(7,41,IL).LT.0.0005) THEN
            RZ(7,41,IL) = SCALRZ*0.0005*XAZ(7,41)
     .                     /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(7,41))
          END IF
          IF(EZ(7,43,IL).LT.0.0005) THEN
            RZ(7,43,IL) = SCALRZ*0.0005*XAZ(7,43)
     .                     /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(7,43))
          END IF
        END DO
      END IF
C
C
Cjrw RUN050 3/13/02 carry RUN043 mixing to Oct-Nov
      IF(TIME.GT.243.AND.TIME.LE.365) THEN
        DO IL=1,10
          DO IC=27,37
            IF(EZ(2,IC,IL).LT.0.00025) THEN
              RZ(2,IC,IL) = SCALRZ*0.00025*XAZ(2,IC)
     .                       /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(2,IC))
            END IF
          END DO
        END DO
      END IF
C
      IF(TIME.GT.0.AND.TIME.LE.61) THEN
        DO IL=1,10
          DO IC=27,37
            IF(EZ(2,IC,IL).LT.0.00025) THEN
              RZ(2,IC,IL) = SCALRZ*0.00025*XAZ(2,IC)
     .                       /(0.5*(DZ(IL)+DZ(IL-1))*HBAR(2,IC))
            END IF
          END DO
        END DO
      END IF
C
      DO IL=1,NLAYR
        RY(10,75,IL) = 0.0
      ENDDO

      IF(LIST(1).EQ.1)  GO TO 110

      WRITE(OUT,8000)
      WRITE(OUT,1500)
 1500 FORMAT(44X,'F L O W S   ( M * * 3 / S E C )'//)
      WRITE(OUT,1501)
 1501 FORMAT(20X,'HORIZONTAL OR X-DIRECTION COMPONENT'/)
      CALL RCAPRNT(QX,1,NLAYR)
      WRITE(OUT,1502)
 1502 FORMAT(20X,'LATERAL OR Y-DIRECTION COMPONENT'/)
      CALL RCAPRNT(QY,1,NLAYR)
      IF (NLAYR.GT.1) WRITE(OUT,1503)
 1503 FORMAT(20X,'VERTICAL OR Z-DIRECTION COMPONENT'/)
      IF (NLAYR.GT.1) CALL RCAPRNT(QZ,1,NLAYR)
    
      WRITE(OUT,8000)
      WRITE(OUT,2000)
 2000 FORMAT(28X,'E X C H A N G E   C O E F F I C I E N T S ',
     .    ' (M * * 3 / S E C )'//)
      WRITE(OUT,2001)
 2001 FORMAT(20X,'HORIZONTAL OR X-DIRECTION COMPONENT'/)
      CALL RCAPRNT(RX,1,NLAYR)
      WRITE(OUT,2002)
 2002 FORMAT(20X,'LATERAL OR Y-DIRECTION COMPONENT'/)
      CALL RCAPRNT(RY,1,NLAYR)
      IF (NLAYR.GT.1) WRITE(OUT,2003)
 2003 FORMAT(20X,'VERTICAL OR Z-DIRECTION COMPONENT'/)
      IF (NLAYR.GT.1) CALL RCAPRNT(RZ,1,NLAYR)
  
C        CONVERT FLOWS AND EXCHANGES TO M^3/DAY

  110 DO 120 IL=1,NLAYR
      DO 120 IC=1,NCOL
      DO 120 IR=1,NROW
          QX(IR,IC,IL) = 86400.*QX(IR,IC,IL)
          QY(IR,IC,IL) = 86400.*QY(IR,IC,IL)
          IF (NLAYR.GT.1) QZ(IR,IC,IL) = 86400.*QZ(IR,IC,IL)
          RX(IR,IC,IL) = 86400.*RX(IR,IC,IL)
          RY(IR,IC,IL) = 86400.*RY(IR,IC,IL)
          IF (NLAYR.GT.1) RZ(IR,IC,IL) = 86400.*RZ(IR,IC,IL)
          EX(IR,IC,IL) = 86400.*EX(IR,IC,IL)
          EY(IR,IC,IL) = 86400.*EY(IR,IC,IL)
          IF (NLAYR.GT.1) EZ(IR,IC,IL) = 86400.*EZ(IR,IC,IL)
          IF (FSM(IR,IC).LE.0) EZ(IR,IC,IL)=0.0
  120 CONTINUE

C        MAKE SURE R ARE ZERO FOR APPROPRIATE LAND AND BC SEGMENTS

      DO 150 IL=1,NLAYR
      DO 150 IC=1,NCOL
      DO 150 IR=1,NROW
         IF(FSM(IR,IC).NE.-1) THEN
           GO TO 150
         ELSE
           IF(IR.LT.NROW .AND. FSM(IR+1,IC).EQ.1) RX(IR+1,IC,IL)=0.
           IF(IR.GT.1    .AND. FSM(IR-1,IC).EQ.1) RX(IR,IC,IL)=0.
           IF(IC.LT.NCOL .AND. FSM(IR,IC+1).EQ.1) RY(IR,IC+1,IL)=0.
           IF(IC.GT.1    .AND. FSM(IR,IC-1).EQ.1) RY(IR,IC,IL)=0.
         ENDIF
  150 CONTINUE

C        COMPUTE CRITICAL INTEGRATION STEPSIZES

      DO 160 IL=1,NLAYR
      DO 160 IC=1,NCOL
      DO 160 IR=1,NROW
       IF(FSM(IR,IC).LE.0)  THEN
        TIMESTEP(IR,IC,IL) = 999.999
       ELSE
        TIMESTEP(IR,IC,IL) = RX(IR,IC,IL) + RX(IR+1,IC,IL)
     .                     + RY(IR,IC,IL) + RY(IR,IC+1,IL)
        IF(QX(IR,IC,IL).LT.0.0)  TIMESTEP(IR,IC,IL) =
     .                              TIMESTEP(IR,IC,IL) - QX(IR,IC,IL)
        IF(QX(IR+1,IC,IL).GT.0.0)  TIMESTEP(IR,IC,IL) =
     .                              TIMESTEP(IR,IC,IL) + QX(IR+1,IC,IL)
        IF(QY(IR,IC,IL).LT.0.0)  TIMESTEP(IR,IC,IL) =
     .                              TIMESTEP(IR,IC,IL) - QY(IR,IC,IL)
        IF(QY(IR,IC+1,IL).GT.0.0)  TIMESTEP(IR,IC,IL) =
     .                              TIMESTEP(IR,IC,IL) + QY(IR,IC+1,IL)
        IF(QZ(IR,IC,IL).GT.0.0)  TIMESTEP(IR,IC,IL) =
     .                              TIMESTEP(IR,IC,IL) + QZ(IR,IC,IL)
        IF(QZ(IR,IC,IL+1).LT.0.0)  TIMESTEP(IR,IC,IL) =
     .                              TIMESTEP(IR,IC,IL) - QZ(IR,IC,IL+1)
        TIMESTEP(IR,IC,IL) = BVOL(IR,IC,IL)/(TIMESTEP(IR,IC,IL)+1.E-20)
       ENDIF
  160 CONTINUE
 
      IF(IDIAGDT.EQ.1)  THEN

      IMIN=1
      DO 180 IL=1,NLAYR
      DO 180 IC=1,NCOL
      DO 180 IR=1,NROW
        IF(FSM(IR,IC).LE.0)  GO TO 180
        IF(IMIN.LT.21)  THEN
           MINDT(IMIN)=TIMESTEP(IR,IC,IL)
           IMINROW(IMIN) = IR
           IMINCOL(IMIN) = IC
           IMINLAYR(IMIN) = IL
           IMIN = IMIN+1
        ELSE
           STEPMIN=TIMESTEP(IR,IC,IL)
           IROWMIN=IR
           ICOLMIN=IC
           ILAYRMIN=IL
           DO 170 IMINR=1,20
             IF(STEPMIN.LT.MINDT(IMINR))   THEN
              TEMPSTOR = MINDT(IMINR)
              MINDT(IMINR)=STEPMIN
              STEPMIN=TEMPSTOR
              ITEMPSTOR=IMINROW(IMINR)
              IMINROW(IMINR) = IROWMIN
              IROWMIN=ITEMPSTOR
              ITEMPSTOR=IMINCOL(IMINR)
              IMINCOL(IMINR) = ICOLMIN
              ICOLMIN=ITEMPSTOR
              ITEMPSTOR=IMINLAYR(IMINR)
              IMINLAYR(IMINR) = ILAYRMIN
              ILAYRMIN=ITEMPSTOR
             ENDIF
  170      CONTINUE
        ENDIF
  180 CONTINUE

      WRITE(OUT,4400)  (MINDT(IMIN),IMINROW(IMIN),IMINCOL(IMIN),
     .   IMINLAYR(IMIN),IMIN=1,20)
 4400 FORMAT(///40X,' MINIMUM TIMESTEP CRITERIA'/
     .          40X,'STEPSIZE     ROW COL LAYER'/
     .          40X,' (DAYS)'/(40X,F7.5,4X,3I4))

      CALL MOVE(NROW*NCOL*NLAYR,TIMESTEP,TIMESTEPS)
      CALL SORT(NROW*NCOL*NLAYR,TIMESTEPS)
      IP1 = 0.01*TOTLWATR
      IP5 = 0.05*TOTLWATR
      IP10 = 0.10*TOTLWATR
      IP15 = 0.15*TOTLWATR
      IP20 = 0.20*TOTLWATR
      WRITE(OUT,4600)  1,TIMESTEPS(1),IP1,TIMESTEPS(IP1),
     .     IP5,TIMESTEPS(IP5),IP10,TIMESTEPS(IP10),
     .     IP15,TIMESTEPS(IP15),IP20,TIMESTEPS(IP20)
 4600 FORMAT(///25X,'DISTRIBUTION OF CRITICAL TIMESTEPS'/
     .  15X,' 0 PERCENT OR',I4,' SEGMENT HAS A TIMESTEP OF LESS THAN',
     .  F10.5,' DAYS'/
     .  15X,' 1 PERCENT OR',I4,' SEGMENTS HAVE A TIMESTEP OF LESS THAN',
     .  F8.5,' DAYS'/
     .  15X,' 5 PERCENT OR',I4,' SEGMENTS HAVE A TIMESTEP OF LESS THAN',
     .  F8.5,' DAYS'/
     .  15X,'10 PERCENT OR',I4,' SEGMENTS HAVE A TIMESTEP OF LESS THAN',
     .  F8.5,' DAYS'/
     .  15X,'15 PERCENT OR',I4,' SEGMENTS HAVE A TIMESTEP OF LESS THAN',
     .  F8.5,' DAYS'/
     .  15X,'20 PERCENT OR',I4,' SEGMENTS HAVE A TIMESTEP OF LESS THAN',
     .  F8.5,' DAYS')
      DO 220 I=1,20
  220 MINDT(I) = 100.

      ENDIF

      IF(IDIAGDT.EQ.0)   RETURN

      DO 250 IL=1,NLAYR
       DO 250 IC=1,NCOL
        DO 250 IR=1,NROW
         TIMESTEP(IR,IC,IL) = 100.
  250 CONTINUE
   
      GO TO 30

C        EXIT POINT IF PERFORMING TIME-STEP DIAGNOSTIC RUN
  300 CALL EXIT

C        HYDRODYNAMIC FILE DOES NOT EXIST ...
C          ERROR MESSAGE AND EXIT
  900 WRITE(OUT,9000)   HYDFILNA
 9000 FORMAT(///5X,'ERROR...THE FOLLOWING HYDRODYNAMIC FILE DOES NOT EXI
     .ST OR IS EMPTY'/5X,A40/5X,'RCA TERMINATED')
      CALL EXIT

C        END OF HYDRODYNAMIC FILE ENCOUNTERED ...
C          CHECK IF RECYCLE OPTION ENABLED
  920 IF(HYDCYCOPT.EQ.1)  THEN
C        IF SO REWIND FILE AND CONTINUE SIMULATION
        REWIND(20)
        GO TO 30
C          OR IF "LINK-FILE" OPTION ENABLED
      ELSE IF(HYDCYCOPT.EQ.2)  THEN
C        IF SO CLOSE PRESENT "GCM" FILE AND OPEN NEW "GCM" FILE
        CLOSE(20)
        READ(IN,1300)   HYDFILNA
        WRITE(OUT,1310)  HYDFILNA
        OPEN(20,FILE=HYDFILNA,FORM='UNFORMATTED',STATUS='OLD',ERR=900)
        GO TO 30
      ELSE
C        ERROR MESSAGE AND EXIT
        WRITE(OUT,9100)   HYDFILNA
 9100   FORMAT(///5X,'END-OF-FILE ENCOUNTERED DURING READ OF'/
     .     5X,A40)
      ENDIF
      CALL EXIT

  960 WRITE(OUT,9600)
 9600 FORMAT(///10X,
     .   ' ERROR...USER REQUESTED MORE HYDRODYNAMIC TIME BREAKS'/
     .   ' THEN DIMENSIONED FOR IN -RCACM- ... RCA TERMINATED')
      CALL EXIT
      END 

      SUBROUTINE LNDWTR(ARRAY,SCRATCHA,ICNT,JCNT)
      INCLUDE 'RCACM'
      REAL   ARRAY(NROW,NCOL,JCNT),SCRATCHA(ICNT,JCNT)
      READ(20)   SCRATCHA
      DO 100 IL=1,JCNT
        DO 100 I=1,ICNT
          ARRAY(IWTRNDX(I),JWTRNDX(I),IL) = SCRATCHA(I,IL)
  100 CONTINUE
      RETURN
      END

      SUBROUTINE MOVE(N,FROM,TO)
      REAL  FROM(N),TO(N)
      DO 10 I=1,N
        TO(I) = FROM(I)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE SORT(N,RA)
      DIMENSION RA(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END
