      SUBROUTINE RCA05
C 
C        RCA05 READS THE FORCING FUNCTIONS
C 
      INCLUDE  'RCACM'

C        NOTE: SINCE LOADS WILL BE DIVIDED BY THE SEGMENT VOLUMES IN
C        FORMULATING THE MASS BALANCE DERIVATIVE EQUATIONS THE FOLLOWING
C        CONVERSION IS NECESSARY 
C           KG/DAY * 10^6 MG/KG * M^3/10^3 L ==> MG*M^3/DAY-L

      WRITE(OUT,8000) 
 8000 FORMAT(/////1X,119('*')//)

C             POINT SOURCE LOADS

      READ(IN,1000)  PSFILNA,IBNRYRDOPTS(2)
 1000 FORMAT(A40,I5)
      WRITE(OUT,1001)  PSFILNA
 1001 FORMAT(//10X,'OPENING PSFILNA = ',A40)
      IF(IBNRYRDOPTS(2).EQ.0)  THEN
        OPEN(22,FILE=PSFILNA,FORM='FORMATTED')
        READ(22,1050,ERR=950) IPSOPT
 1050   FORMAT(3I5) 
        IF(IPSOPT.EQ.2)  READ(22,2300,ERR=950)  NXPST
 2300   FORMAT(10X,7F10.0) 
      ELSE
        OPEN(22,FILE=PSFILNA,FORM='UNFORMATTED')
        READ(22) IPSOPT
        IF(IPSOPT.EQ.2)  READ(22)  NXPST
      ENDIF

      DO 100 ISYS=1,NOSYS 

      IF(IBNRYRDOPTS(2).EQ.0)  THEN
        READ(22,1050,ERR=950) NOPS(ISYS)
      ELSE
        READ(22) NOPS(ISYS)
      ENDIF
      IF(NOPS(ISYS).GT.NWK)  GO TO 960
      IF(NOPS(ISYS).EQ.0)   GO TO 90
      WRITE(OUT,2001) ISYS
 2001 FORMAT(//42X,'POINT SOURCE LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)
 2150 FORMAT(41X,11('-'),3X,A8,3X,12('-')/)
      WRITE(OUT,2101) IPSOPT,NOPS(ISYS)
 2101 FORMAT(39X,'PS OPTION',I3,' USED',5X,'NO.OF WK''S READ',I5/)
      IF(IBNRYRDOPTS(2).EQ.0)  THEN
        READ(22,1500,ERR=950)  SCALPS(ISYS)
      ELSE
        READ(22)  SCALPS(ISYS)
      ENDIF
 1500 FORMAT(E10.3) 
      WRITE(OUT,1600)  SCALPS(ISYS)
 1600 FORMAT(47X,'SCALE FACTOR',E13.3/) 

      IF(IPSOPT.EQ.1)  THEN

        IF(LIST(3).EQ.0)  WRITE(OUT,2201) 
 2201   FORMAT(12X,4(8X,'PS  ROW COL LYR ')/) 
        IF(IBNRYRDOPTS(2).EQ.0)  THEN
          READ(22,1100,ERR=950)  (BPS(I,ISYS),(IPS(J,I,ISYS),J=1,3),
     .        I=1,NOPS(ISYS)) 
 1100   FORMAT(4(F10.0,1X,3I3)) 
        ELSE
          READ(22)  (BPS(I,ISYS),(IPS(J,I,ISYS),J=1,3),I=1,NOPS(ISYS))
        ENDIF
        IF(LIST(3).EQ.0)  WRITE(OUT,3300)   (BPS(I,ISYS),
     .      (IPS(J,I,ISYS),J=1,3),I=1,NOPS(ISYS))
 3300   FORMAT(11X,E12.4,3I4,E12.4,3I4,E12.4,3I4,E12.4,3I4)
        DO 15 I=1,NOPS(ISYS)
          BPS(I,ISYS) = 1000.*SCALPS(ISYS)*BPS(I,ISYS)
   15   CONTINUE

      ELSE

        IF(LIST(3).EQ.0)   WRITE(OUT,2601)   NXPST
 2601   FORMAT(40X,'POINT SOURCE LOADINGS AT TIME =',F6.0//
     .      4(6X,'ROW COL LYR',6X,'LOAD',3X)/)
        IF(IBNRYRDOPTS(2).EQ.0)  THEN
          READ(22,2700,ERR=950)  ((IPS(J,I,ISYS),J=1,3),I=1,NOPS(ISYS))
 2700     FORMAT(10X,I4,2I3,I4,2I3,I4,2I3,I4,2I3,I4,2I3,I4,2I3,I4,2I3)
          READ(22,2750,ERR=950)  (BPS(I,ISYS),I=1,NOPS(ISYS))
 2750     FORMAT(10X,7F10.0)
        ELSE
          READ(22)  ((IPS(J,I,ISYS),J=1,3),I=1,NOPS(ISYS))
          READ(22)  (BPS(I,ISYS),I=1,NOPS(ISYS))
        ENDIF
        IF(LIST(3).EQ.0)   WRITE(OUT,2800)   ((IPS(J,I,ISYS),J=1,3)
     .        ,BPS(I,ISYS),I=1,NOPS(ISYS))
 2800   FORMAT(4(5X,3I4,E13.3))
        DO 40 I=1,NOPS(ISYS)
          BPS(I,ISYS) = 1000.*SCALPS(ISYS)*BPS(I,ISYS) 
   40   CONTINUE

      ENDIF

      GO TO 100 

   90 WRITE(OUT,5001)    ISYS 
 5001 FORMAT(///42X,'NO POINT SOURCE LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)

  100 CONTINUE

      IF(IPSOPT.EQ.2)  THEN
        IF(IBNRYRDOPTS(2).EQ.0)  THEN
          READ(22,2300,ERR=950)  NXPST
        ELSE
          READ(22)  NXPST
        ENDIF
      ENDIF

C             NONPOINT SOURCE LOADS

      READ(IN,1000)  NPSFILNA,IBNRYRDOPTS(3)
      WRITE(OUT,1002)  NPSFILNA
 1002 FORMAT(//10X,'OPENING NPSFILNA = ',A40)
      IF(IBNRYRDOPTS(3).EQ.0)  THEN
        OPEN(23,FILE=NPSFILNA,FORM='FORMATTED')
        READ(23,1050,ERR=950) INPSOPT
        IF(INPSOPT.EQ.2)  READ(23,2300,ERR=950)  NXNPST
      ELSE
        OPEN(23,FILE=NPSFILNA,FORM='UNFORMATTED')
        READ(23) INPSOPT
        IF(INPSOPT.EQ.2)  READ(23)  NXNPST
      ENDIF

      DO 200 ISYS=1,NOSYS 

      IF(IBNRYRDOPTS(3).EQ.0)  THEN
        READ(23,1050,ERR=950) NONPS(ISYS)
      ELSE
        READ(23) NONPS(ISYS)
      ENDIF
      IF(NONPS(ISYS).GT.NWK)  GO TO 962
      IF(NONPS(ISYS).EQ.0)   GO TO 190
      WRITE(OUT,2002) ISYS
 2002 FORMAT(//41X,'NONPOINT SOURCE LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)
      WRITE(OUT,2102) INPSOPT,NONPS(ISYS)
 2102 FORMAT(39X,'NPS OPTION',I3,' USED',5X,'NO.OF WKS''S READ',I5/)
      IF(IBNRYRDOPTS(3).EQ.0)  THEN
        READ(23,1500,ERR=950)  SCALNPS(ISYS)
      ELSE
        READ(23)  SCALNPS(ISYS)
      ENDIF
      WRITE(OUT,1600)  SCALNPS(ISYS)

      IF(INPSOPT.EQ.1)  THEN

        IF(LIST(3).EQ.0)  WRITE(OUT,2202) 
 2202   FORMAT(12X,4(7X,'NPS  ROW COL LYR ')/) 
        IF(IBNRYRDOPTS(3).EQ.0)  THEN
          READ(23,1100,ERR=950)  (BNPS(I,ISYS),(INPS(J,I,ISYS),J=1,3),
     .        I=1,NONPS(ISYS)) 
        ELSE
          READ(23)  (BNPS(I,ISYS),(INPS(J,I,ISYS),J=1,3),
     .        I=1,NONPS(ISYS))
        ENDIF
        IF(LIST(3).EQ.0)  WRITE(OUT,3300)   (BNPS(I,ISYS)
     .      ,(INPS(J,I,ISYS),J=1,3),I=1,NONPS(ISYS))
C        MULTIPLY BY SCALE FACTOR AND APPLY CONVERSION FACTOR
        DO 115 I=1,NONPS(ISYS)
          BNPS(I,ISYS) = 1000.*SCALNPS(ISYS)*BNPS(I,ISYS)
  115   CONTINUE

      ELSE

        IF(LIST(3).EQ.0)   WRITE(OUT,2602)   NXNPST
 2602   FORMAT(40X,'NONPOINT SOURCE LOADINGS AT TIME =',F6.0//
     .      4(6X,'ROW COL LYR',6X,'LOAD',3X)/)
        IF(IBNRYRDOPTS(3).EQ.0)  THEN
          READ(23,2700,ERR=950) ((INPS(J,I,ISYS),J=1,3),I=1,NONPS(ISYS))
          READ(23,2750,ERR=950)  (BNPS(I,ISYS),I=1,NONPS(ISYS))
        ELSE
          READ(23) ((INPS(J,I,ISYS),J=1,3),I=1,NONPS(ISYS))
          READ(23)  (BNPS(I,ISYS),I=1,NONPS(ISYS))
        ENDIF
        IF(LIST(3).EQ.0)   WRITE(OUT,2800)   ((INPS(J,I,ISYS),J=1,3)
     .        ,BNPS(I,ISYS),I=1,NONPS(ISYS))
        DO 140 I=1,NONPS(ISYS)
          BNPS(I,ISYS) = 1000.*SCALNPS(ISYS)*BNPS(I,ISYS) 
  140   CONTINUE

      ENDIF

      GO TO 200 

  190 WRITE(OUT,5002)    ISYS 
 5002 FORMAT(///42X,'NO NONPOINT SOURCE LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)

  200 CONTINUE

      IF(INPSOPT.EQ.2)  THEN
        IF(IBNRYRDOPTS(3).EQ.0)  THEN
          READ(23,2300,ERR=950)  NXNPST
        ELSE
          READ(23)  NXNPST
        ENDIF
      ENDIF

C             FALL-LINE LOADS

      READ(IN,1000)  FLFILNA,IBNRYRDOPTS(4)
      WRITE(OUT,1003)  FLFILNA
 1003 FORMAT(//10X,'OPENING FLFILNA = ',A40)
      IF(IBNRYRDOPTS(4).EQ.0)  THEN
        OPEN(24,FILE=FLFILNA,FORM='FORMATTED')
        READ(24,1050,ERR=950) IFLOPT
        IF(IFLOPT.EQ.2)  READ(24,2300,ERR=950)  NXFLT
      ELSE
        OPEN(24,FILE=FLFILNA,FORM='UNFORMATTED')
        READ(24) IFLOPT
        IF(IFLOPT.EQ.2)  READ(24)  NXFLT
      ENDIF

      DO 300 ISYS=1,NOSYS 

      IF(IBNRYRDOPTS(4).EQ.0)  THEN
        READ(24,1050,ERR=950) NOFL(ISYS)
      ELSE
        READ(24) NOFL(ISYS)
      ENDIF
      IF(NOFL(ISYS).GT.NWK)  GO TO 964
      IF(NOFL(ISYS).EQ.0)   GO TO 290
      WRITE(OUT,2003) ISYS
 2003 FORMAT(//43X,'FALL-LINE LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)
      WRITE(OUT,2103) IFLOPT,NOFL(ISYS)
 2103 FORMAT(39X,'FL OPTION',I3,' USED',5X,'NO.OF FL''S READ',I5/)
      IF(IBNRYRDOPTS(4).EQ.0)  THEN
        READ(24,1500,ERR=950)  SCALFL(ISYS)
      ELSE
        READ(24)  SCALFL(ISYS)
      ENDIF
      WRITE(OUT,1600)  SCALFL(ISYS)

      IF(IFLOPT.EQ.1)  THEN

        IF(LIST(3).EQ.0)  WRITE(OUT,2203) 
 2203   FORMAT(12X,4(8X,'FL  ROW COL LYR ')/) 
      IF(IBNRYRDOPTS(4).EQ.0)  THEN
        READ(24,1100,ERR=950)  (BFL(I,ISYS),(IFL(J,I,ISYS),J=1,3),
     .        I=1,NOFL(ISYS)) 
      ELSE
        READ(24)  (BFL(I,ISYS),(IFL(J,I,ISYS),J=1,3),I=1,NOFL(ISYS)) 
      ENDIF
        IF(LIST(3).EQ.0)  WRITE(OUT,3300)   (BFL(I,ISYS)
     .      ,(IFL(J,I,ISYS),J=1,3),I=1,NOFL(ISYS))
C        MULTIPLY BY SCALE FACTOR AND APPLY CONVERSION FACTOR
        DO 215 I=1,NOFL(ISYS)
          BFL(I,ISYS) = 1000.*SCALFL(ISYS)*BFL(I,ISYS)
  215  CONTINUE

      ELSE

        IF(LIST(3).EQ.0)   WRITE(OUT,2603)   NXFLT
 2603   FORMAT(40X,'FALL-LINE LOADINGS AT TIME =',F6.0//
     .      4(6X,'ROW COL LYR',6X,'LOAD',3X)/)
        IF(IBNRYRDOPTS(4).EQ.0)  THEN
          READ(24,2700,ERR=950)  ((IFL(J,I,ISYS),J=1,3),I=1,NOFL(ISYS))
          READ(24,2750,ERR=950)  (BFL(I,ISYS),I=1,NOFL(ISYS))
        ELSE
          READ(24)  ((IFL(J,I,ISYS),J=1,3),I=1,NOFL(ISYS))
          READ(24)  (BFL(I,ISYS),I=1,NOFL(ISYS))
        ENDIF
        IF(LIST(3).EQ.0)   WRITE(OUT,2800)   ((IFL(J,I,ISYS),J=1,3)
     .        ,BFL(I,ISYS),I=1,NOFL(ISYS))
        DO 240 I=1,NOFL(ISYS)
          BFL(I,ISYS) = 1000.*SCALFL(ISYS)*BFL(I,ISYS) 
  240   CONTINUE

      ENDIF


      GO TO 300 

  290 WRITE(OUT,5003)    ISYS 
 5003 FORMAT(///42X,'NO FALL-LINE LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)

  300 CONTINUE


      IF(IFLOPT.EQ.2)  THEN
        IF(IBNRYRDOPTS(4).EQ.0)  THEN
          READ(24,2300,ERR=950)  NXFLT
        ELSE
          READ(24)  NXFLT
        ENDIF
      ENDIF

C             ATMOSPHERIC LOADS

      READ(IN,1000)  ATMFILNA,IBNRYRDOPTS(5)
      WRITE(OUT,1004)  ATMFILNA
 1004 FORMAT(//10X,'OPENING ATMFILNA = ',A40)
      IF(IBNRYRDOPTS(5).EQ.0)  THEN
        OPEN(25,FILE=ATMFILNA,FORM='FORMATTED')
        READ(25,1050,ERR=950) IATMOPT
        IF(IATMOPT.EQ.2)  READ(25,2300,ERR=950)  NXATMT
      ELSE
        OPEN(25,FILE=ATMFILNA,FORM='UNFORMATTED')
        READ(25) IATMOPT
        IF(IATMOPT.EQ.2)  READ(25)  NXATMT
      ENDIF

      DO 400 ISYS=1,NOSYS 

      IF(IBNRYRDOPTS(5).EQ.0)  THEN
        READ(25,1050,ERR=950) NOATM(ISYS)
      ELSE
        READ(25) NOATM(ISYS)
      ENDIF
      IF(NOATM(ISYS).EQ.0)   GO TO 390
      WRITE(OUT,2004) ISYS
 2004 FORMAT(//43X,'ATMOSPHERIC LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)
      WRITE(OUT,2104) IATMOPT,NOATM(ISYS)
 2104 FORMAT(39X,'ATM OPTION',I3,' USED',5X,'NO.OF ATM''S READ',I5/)
      IF(IBNRYRDOPTS(5).EQ.0)  THEN
        READ(25,1500,ERR=950)  SCALATM(ISYS)
      ELSE
        READ(25)  SCALATM(ISYS)
      ENDIF
      WRITE(OUT,1600)  SCALATM(ISYS)

      IF(IATMOPT.EQ.1)  THEN

        IF(IBNRYRDOPTS(5).EQ.0)  THEN
          READ(25,1100,ERR=950)  BATM(ISYS)
        ELSE
          READ(25)  BATM(ISYS)
        ENDIF
        IF(LIST(3).EQ.0)  WRITE(OUT,2204)  BATM(ISYS)
 2204   FORMAT(42X,'ATMOSPHERIC LOADING =',E13.3)
C        MULTIPLY BY SCALE FACTOR AND APPLY CONVERSION FACTOR
C          KG/M^2-DAY ==> MG*M^3/DAY-M^2-L
        BATM(ISYS) = 1000.*SCALATM(ISYS)*BATM(ISYS)

      ELSE

        IF(IBNRYRDOPTS(5).EQ.0)  THEN
          READ(25,2750,ERR=950)  BATM(ISYS)
        ELSE
          READ(25)  BATM(ISYS)
        ENDIF
        IF(LIST(3).EQ.0)   WRITE(OUT,2604)   NXATMT,BATM(ISYS)
 2604   FORMAT(40X,'ATMOSPHERIC LOADING AT TIME ',F6.1,' EQUALS',E10.3)
        BATM(ISYS) = 1000.*SCALATM(ISYS)*BATM(ISYS) 

      ENDIF

      GO TO 400 

  390 WRITE(OUT,5004)    ISYS 
 5004 FORMAT(///42X,'NO ATMOSPHERIC LOADINGS FOR SYSTEM',I3) 
      WRITE(OUT,2150)   SYNAME(ISYS)

  400 CONTINUE

      IF(IATMOPT.EQ.2) THEN
        IF(IBNRYRDOPTS(5).EQ.0)  THEN
          READ(25,2300,ERR=950)  NXATMT
        ELSE
          READ(25)  NXATMT
        ENDIF
      ENDIF

      RETURN

  950 CALL FMTER
      CALL EXIT 
  960 WRITE(OUT,9600)  
 9600 FORMAT(//11X,'ERROR...USER REQUESTING MORE POINT SOURCE LOADS THAN
     . DIMENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
  962 WRITE(OUT,9602)  
 9602 FORMAT(//11X,'ERROR...USER REQUESTING MORE NONPOINT SOURCE LOADS T
     .HAN DIMENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
  964 WRITE(OUT,9604)  
 9604 FORMAT(//11X,'ERROR...USER REQUESTING MORE FALL-LINE LOADS THAN DI
     .MENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
      END 
