      SUBROUTINE RCA06
C 
C        RCA06 READS PARAMS, CONST, AND MISC TIME FUNCTIONS
C 
      INCLUDE  'RCACM'
      CHARACTER  PNAME*20,CNAME(150)*5
      REAL   VALT(500),TVAL(500),PSCAL(30)

C         P A R A M E T E R S 

      WRITE(OUT,8000) 
 8000 FORMAT(/////1X,119('*')//)

      READ(IN,1000)  PCFILNA,IBNRYRDOPT
 1000 FORMAT(A40,I5)
      WRITE(OUT,1005)  PCFILNA
 1005 FORMAT(10X,'OPENING PCFILNA = ',A40//)
      IF(IBNRYRDOPT.EQ.0)  THEN
        OPEN(26,FILE=PCFILNA,FORM='FORMATTED')
      ELSE
        OPEN(26,FILE=PCFILNA,FORM='UNFORMATTED')
      ENDIF

C        DEPTH INDEPENDENT (2-D)

      IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1001,ERR=950) NOPAM 
 1001   FORMAT(2I5) 
      ELSE
        READ(26) NOPAM 
      ENDIF
      IF(NOPAM.GT.NPARM2D)  GO TO 960
      IF(NOPAM.EQ.0)   GO TO 120
      IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1100,ERR=950)    (PSCAL(I),I=1,NOPAM) 
 1100   FORMAT(8F10.0)
      ELSE
        READ(26)    (PSCAL(I),I=1,NOPAM) 
      ENDIF
      WRITE(OUT,1002)    (PSCAL(I),I=1,NOPAM) 
 1002 FORMAT(/////51X,'LAYER INDEPENDENT (2-D) PARAMETERS'
     .   //8X,'SCALE'/6X,'FACTORS',5(6X,E14.5)/13X,5(6X,E14.5))
      DO 100 I=1,NOPAM
        IF(IBNRYRDOPT.EQ.0)  THEN
          READ(26,1200,ERR=950)   PNAME
 1200     FORMAT(A20)
        ELSE
          READ(26)   PNAME
        ENDIF
        WRITE(OUT,1110)   PNAME
 1110   FORMAT(//20X,A20)
        DO 75 IC=1,NCOL
          IF(IBNRYRDOPT.EQ.0)  THEN
            READ(26,1100,ERR=950)   (PARAM2D(IR,IC,I),IR=1,NROW)
          ELSE
            READ(26)   (PARAM2D(IR,IC,I),IR=1,NROW)
          ENDIF
          IF(LIST(4).EQ.0)  THEN
           WRITE(OUT,1052) 
 1052      FORMAT(10X,'COL',43X,'ROW'/25X,'2',15X,'3',14X,'...'/)
           WRITE(OUT,1202)   IC,(PARAM2D(IR,IC,I),IR=1,NROW)
 1202      FORMAT(10X,I4,1X,8(2X,E13.5)/15X,8(2X,E13.5)/
     .            15X,8(2X,E13.5))
          ENDIF
C        INCORPORATE SCALE FACTOR
          DO 50 IR=1,NROW
            PARAM2D(IR,IC,I) = PARAM2D(IR,IC,I)*PSCAL(I) 
   50     CONTINUE
   75   CONTINUE
  100 CONTINUE

C        DEPTH DEPENDENT (3-D)

  120 IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1001,ERR=950) NOPAM 
      ELSE
        READ(26) NOPAM 
      ENDIF
      IF(NOPAM.GT.NPARM3D)  GO TO 962
      IF(NOPAM.EQ.0)   GO TO 220
      IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1100,ERR=950)    (PSCAL(I),I=1,NOPAM) 
      ELSE
        READ(26)    (PSCAL(I),I=1,NOPAM) 
      ENDIF
      WRITE(OUT,1003)    (PSCAL(I),I=1,NOPAM) 
 1003 FORMAT(/////51X,'LAYER DEPENDENT (3-D) PARAMETERS'
     .   //8X,'SCALE'/6X,'FACTORS',5(6X,E14.5)/13X,5(6X,E14.5))
      DO 200 I=1,NOPAM
        IF(IBNRYRDOPT.EQ.0)  THEN
          READ(26,1200,ERR=950)   PNAME
        ELSE
          READ(26)   PNAME
        ENDIF
        WRITE(OUT,1110)   PNAME
        DO 180 IL=1,NLAYR
          DO 160 IC=1,NCOL
            IF(IBNRYRDOPT.EQ.0)  THEN
              READ(26,1100,ERR=950)   (PARAM3D(IR,IC,IL,I),IR=1,NROW)
            ELSE
              READ(26)   (PARAM3D(IR,IC,IL,I),IR=1,NROW)
            ENDIF
            IF(LIST(4).EQ.0)  THEN
              WRITE(OUT,1053) 
 1053         FORMAT(4X,'LAYER COL',43X,'ROW'/25X,'2',15X,'3',
     .               14X,'...'/)
              WRITE(OUT,1203)   IL,IC,(PARAM3D(IR,IC,IL,I),IR=1,NROW)
 1203         FORMAT(6X,I2,2X,I4,1X,8(2X,E13.5)/15X,8(2X,E13.5)/
     .          15X,8(2X,E13.5)/15X,8(2X,E13.5)/15X,8(2X,E13.5)/
     .          15X,8(2X,E13.5)/15X,8(2X,E13.5)/15X,8(2X,E13.5))
            ENDIF
C        INCORPORATE SCALE FACTOR
            DO 140 IR=1,NROW
              PARAM3D(IR,IC,IL,I) = PARAM3D(IR,IC,IL,I)*PSCAL(I) 
  140       CONTINUE
  160     CONTINUE
  180   CONTINUE
  200 CONTINUE

C         C O N S T A N T S 

  220 IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1001,ERR=950)   NOCONS 
      ELSE
        READ(26)   NOCONS 
      ENDIF
      IF(NOCONS.GT.NCONS)  GO TO 964
      IF(NOCONS.EQ.0)   GO TO 250
      IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1300,ERR=950)   (CNAME(I),CONST(I),I=1,NOCONS)
 1300   FORMAT(5(A5,F10.0))
      ELSE
        READ(26)   (CNAME(I),CONST(I),I=1,NOCONS)
      ENDIF
      IF(LIST(4).EQ.0)  THEN
        WRITE(OUT,1400)   (CNAME(I),CONST(I),I=1,NOCONS)
 1400   FORMAT(//55X,'CONSTANTS'//8X,5(2X,A5,'=',E13.5)/ 
     .        (10X,A5,'=',E13.5,2X,A5,'=',E13.5,2X,A5,'=',E13.5,2X,
     .         A5,'=',E13.5,2X,A5,'=',E13.5)) 
      ENDIF

C        M I S C   T I M E   F U N C T I O N S

  250 IF(IBNRYRDOPT.EQ.0)  THEN
        READ(26,1001,ERR=950)  NOFUNC,ITVFPLOPT
      ELSE
        READ(26)  NOFUNC,ITVFPLOPT
      ENDIF
      IF(NOFUNC.GT.NFUNC)  GO TO 966
      IF(NOFUNC.EQ.0)   GO TO 350
      OPEN(UNIT=34,FORM='UNFORMATTED')
      WRITE(OUT,1600)
 1600 FORMAT(//45X,'MODEL DEPENDENT TIME FUNCTIONS')
      IF(ITVFPLOPT.EQ.0)   THEN
        WRITE(OUT,1610)
 1610   FORMAT(/37X,'THE USER SELECTED STEP FUNCTION INTERPOLATION')
      ELSE
        WRITE(OUT,1620)
 1620   FORMAT(/35X,'THE USER SELECTED PIECEWISE LINEAR INTERPOLATION')
      ENDIF
      WRITE(OUT,1650) 
 1650 FORMAT(/6X,5(7X,'VAL(T)',6X,'T',2X)/) 
      DO 300 I=1,NOFUNC
        IF(IBNRYRDOPT.EQ.0)  THEN
          READ(26,1700,ERR=950)   PNAME,NOBRK
 1700     FORMAT(A5,I5)
          IF(NOBRK.GT.500)  GO TO 966
          READ(26,1800,ERR=950)   (VALT(J),TVAL(J),J=1,NOBRK)
 1800     FORMAT(8F10.0) 
        ELSE
          READ(26)   PNAME,NOBRK
          IF(NOBRK.GT.500)  GO TO 966
          READ(26)   (VALT(J),TVAL(J),J=1,NOBRK)
        ENDIF
        IF(LIST(4).EQ.0)  THEN
          WRITE(OUT,2000)   PNAME,(VALT(J),TVAL(J),J=1,NOBRK)
 2000     FORMAT(1X,A5,5(E15.5,F7.2)/(6X,E15.5,F7.2,E15.5,F7.2
     .          ,E15.5,F7.2,E15.5,F7.2,E15.5,F7.2)) 
        ENDIF
        IF(I.EQ.1)   WRITE(34)   NOBRK,(TVAL(J),J=1,NOBRK)
        IF(ITVFPLOPT.EQ.0)  THEN
          MFUNC(I) = 0.
          BFUNC(I) = VALT(1) 
        ELSE
          MFUNC(I) = (VALT(2)-VALT(1))/(TVAL(2)-TVAL(1))
          BFUNC(I) = VALT(2)
        ENDIF
        WRITE(34)   NOBRK,(VALT(J),J=1,NOBRK) 
  300 CONTINUE
      NXFUNT = TVAL(2)
      ITIMF = 2

  350 RETURN

  950 CALL FMTER
      CALL EXIT 
  960 WRITE(OUT,9600)  
 9600 FORMAT(//11X,'ERROR...USER REQUESTING MORE 2-D PARAMETERS THAN DIM
     .ENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
  962 WRITE(OUT,9602)  
 9602 FORMAT(//11X,'ERROR...USER REQUESTING MORE 3-D PARAMETERS THAN DIM
     .ENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
  964 WRITE(OUT,9604)  
 9604 FORMAT(//11X,'ERROR...USER REQUESTING MORE CONSTANTS THAN DIMENSIO
     .NED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
  966 WRITE(OUT,9606)  
 9606 FORMAT(//11X,'ERROR...USER REQUESTING MORE TIME FUNCTIONS THAN DIM
     .ENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
  968 WRITE(OUT,9608)  
 9608 FORMAT(//11X,'ERROR...USER REQUESTING MORE TIME BREAKS THAN DIMENS
     .IONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
      END 
