      SUBROUTINE RCA07
C 
C        RCA07 READS THE INITIAL CONDITIONS
C 
      INCLUDE  'RCACM'
      REAL   CARAYSL(NROW,NCOL,NSL),SIGDEPTH(NLAYR)
      REAL   CSTD(NSL),CSIGMA(NLAYR)

      WRITE(OUT,8000) 
 8000 FORMAT(/////1X,119('*')//)
      IF(ISIM.EQ.0)   WRITE(OUT,1000) 
 1000 FORMAT(///42X,'I N I T I A L   C O N D I T I O N S'//)
      IF(ISIM.EQ.1)   WRITE(OUT,1100) 
 1100 FORMAT(///34X,'I N I T I A L   S O L U T I O N   E S T I M A T E S
     .'//)

      READ(IN,1150)  ICFILNA,IBNRYRDOPT
 1150 FORMAT(A40,I5)
      IF(IBNRYRDOPT.EQ.0)  THEN
        OPEN(27,FILE=ICFILNA,FORM='FORMATTED')
      ELSE
        OPEN(27,FILE=ICFILNA,FORM='UNFORMATTED')
      ENDIF

      IF(CYCLE.EQ.0)   THEN

C        READ SIGMA-LEVEL/STANDARD LEVEL OPTION
       IF(IBNRYRDOPT.EQ.0)  THEN
         READ(27,1175,ERR=950)  ICOPT
       ELSE
         READ(27)  ICOPT
       ENDIF
 1175  FORMAT(I5)
       IF(ICOPT.EQ.0)  THEN
C        SIGMA-LEVEL INPUT
         DO 100 ISYS=1,NOSYS 
          DO 100 IL=1,NLAYR
           DO 100 IC=1,NCOL
            IF(IBNRYRDOPT.EQ.0)  THEN
              READ(27,1200,ERR=950)   (CARAY(IR,IC,IL,ISYS),IR=1,NROW) 
 1200         FORMAT(10X,7F10.0)
            ELSE
              READ(27)   (CARAY(IR,IC,IL,ISYS),IR=1,NROW) 
            ENDIF
  100    CONTINUE

       ELSE

C        STANDARD LEVEL INPUT
         DO 170 ISYS=1,NOSYS
           IF(ISIM.EQ.0)   WRITE(OUT,1400)   ISYS
 1400      FORMAT(//44X,'INITIAL CONDITIONS FOR SYSTEM',I3)
           IF(ISIM.EQ.1)   WRITE(OUT,1500)   ISYS
 1500      FORMAT(//40X,'INITIAL SOLUTION ESTIMATES FOR SYSTEM',I3)
           WRITE(OUT,2150)   SYNAME(ISYS)
 2150      FORMAT(44X,9('-'),3X,A8,3X,9('-')//) 
C          READ STANDARD LEVEL DEPTHS
           IF(IBNRYRDOPT.EQ.0)  THEN
             READ(27,1175,ERR=950)  NLVLS
             IF(NLVLS.GT.NSL)  GO TO 970
             READ(27,1200,ERR=950)  (SLDEPTH(I,ISYS),I=1,NLVLS)
           ELSE
             READ(27)  NLVLS
             IF(NLVLS.GT.NSL)  GO TO 970
             READ(27)  (SLDEPTH(I,ISYS),I=1,NLVLS)
           ENDIF
           IF(LIST(5).EQ.0)   WRITE(OUT,1300)  ISYS,
     .          (I,I=1,10),(SLDEPTH(I,ISYS),I=1,NLVLS)
 1300      FORMAT(42X,'STANDARD LEVEL DEPTHS FOR SYSTEM',I3/
     .         17X,10(I2,8X)/(11X,10F10.2))
           DO 105 I=1,NLVLS
             SLDEPTH(I,ISYS) = -SLDEPTH(I,ISYS)
  105      CONTINUE

           IF(LIST(5).EQ.0)  WRITE(OUT,1350)   (I,I=1,10)
 1350      FORMAT(/43X,'CONCENTRATIONS AT STANDARD LEVELS'/
     .        2X,'ROW COL',8X,10(I2,8X))

           DO 125 IL=1,NLVLS
            DO 115 IC=1,NCOL
             IF(IBNRYRDOPT.EQ.0)  THEN
               READ(27,1200,ERR=950)  (CARAYSL(IR,IC,IL),IR=1,NROW)
             ELSE
               READ(27)  (CARAYSL(IR,IC,IL),IR=1,NROW)
             ENDIF
  115       CONTINUE
             IF(LIST(5).EQ.0)   CALL RCAPRNT(CARAYSL(1,1,1),IL,IL)
  125      CONTINUE

           DO 150 IC=1,NCOL
            DO 150 IR=1,NROW
             DO 130 IL=1,NLAYR
              SIGDEPTH(IL) = -ZZ(IL)*H(IR,IC)
              CSIGMA(IL) = 0.0
  130        CONTINUE
             DO 140 IL=1,NLVLS
              CSTD(IL) = CARAYSL(IR,IC,IL)
  140        CONTINUE

             CALL SINTER(SLDEPTH(1,ISYS),CSTD,SIGDEPTH
     .             ,CSIGMA,NLVLS,NLAYR)

             DO 145 IL=1,NLAYR
              CARAY(IR,IC,IL,ISYS) = CSIGMA(IL)
  145        CONTINUE
  150      CONTINUE

  170    CONTINUE
       ENDIF

      ELSE

         READ(15)  CARAY

      ENDIF

      IF(ICOPT.EQ.1)  WRITE(OUT,1380) 
 1380 FORMAT(//33X,'INITIAL CONDITIONS AFTER TRANSFORMATION TO SIGMA-LEV
     .ELS'/)

      IF(LIST(5).EQ.0)  THEN
       DO 180 ISYS=1,NOSYS
         IF(ISIM.EQ.0)   WRITE(OUT,1400)   ISYS
         IF(ISIM.EQ.1)   WRITE(OUT,1500)   ISYS
         WRITE(OUT,2150)   SYNAME(ISYS)
         CALL RCAPRNT(CARAY(1,1,1,ISYS),1,NLAYR)
 180    CONTINUE
      ENDIF

C        MOVE BOUNDARY CONDITIONS TO -CARAY-
      DO 200 ISYS=1,NOSYS
      IF(NOBC(ISYS).EQ.0)  GO TO 200
      DO 190 I=1,NOBC(ISYS)
       CARAY(IBC(1,I,ISYS),IBC(2,I,ISYS),IBC(3,I,ISYS),ISYS)=BBC(I,ISYS)
  190 CONTINUE
  200 CONTINUE

      READ(IN,1200,ERR=950)   (CMAX(I),I=1,NOSYS) 
      READ(IN,1200,ERR=950)   (CMIN(I),I=1,NOSYS) 
      WRITE(OUT,3000)   (I,CMAX(I),CMIN(I),I=1,NOSYS) 
 3000 FORMAT(///32X,'STABILITY AND ACCURACY CRITERIA FOR NUMERICAL SOLUT
     .ION'//33X,'SYSTEM   MAXIMUM CONCENTRATION',10X,'EPSILON'/ 
     .   (34X,I3,10X,E10.4,14X,E10.4))

      RETURN

  950 CALL FMTER
      CALL EXIT 
  970 WRITE(OUT,9700)  
 9700 FORMAT(//11X,'ERROR...USER REQUESTING MORE STANDARD LEVELS THAN DI
     .MENSIONED FOR IN -RCACM-'/11X,'RCA TERMINATED'//)
      CALL EXIT 
      END 
