      SUBROUTINE RCA11
C 
C        RCA11 UPDATES THE BOUNDARY CONCENTRATIONS 
C 
      INCLUDE  'RCACM'
      REAL  SLBC(NSL),SIGDEPTH(NLAYR),SIGBC(NLAYR)

      IF(IBCPLOPT.EQ.1)  THEN
        OLDBCT = NXBCT
        IF(IBNRYRDOPTS(1).EQ.0) THEN
          READ(21,1100,ERR=950)  NXBCT
        ELSE
          READ(21,ERR=950)  NXBCT
        END IF
      ENDIF

      IF(LIST(2).EQ.0)   WRITE(OUT,1000)   NXBCT
 1000 FORMAT(40X,'BOUNDARY CONDITIONS AT TIME =',F8.2)
      IF(IBCPLOPT.EQ.0)  GO TO 50

      DO 20 ISYS=1,NOSYS
        IF(NOBC(ISYS).EQ.0)  GO TO 20
        DO 10 I=1,NOBC(ISYS)
          SBC(I,ISYS) = BBC(I,ISYS)
   10   CONTINUE
   20 CONTINUE

   50 DO 200 ISYS=1,NOSYS 
      IF(NOBC(ISYS).EQ.0)   GO TO 200

      WRITE(OUT,1200) ISYS
 1200 FORMAT(//41X,'BOUNDARY CONCENTRATIONS FOR SYSTEM',I3) 
      WRITE(OUT,1250)   SYNAME(ISYS)
 1250 FORMAT(41X,11('-'),3X,A8,3X,12('-')//) 

      IF(IBCOPT.EQ.4)  GO TO 100

C        SIGMA-LEVELS
      IF(LIST(2).EQ.0)   WRITE(OUT,2000)
 2000 FORMAT(4(6X,'ROW COL LYR',6X,'CONC',3X))

      IF (IBNRYRDOPTS(1).EQ.0) THEN
      READ(21,2100,ERR=950)  (BBC(I,ISYS),I=1,NOBC(ISYS))
      ELSE
      READ(21,ERR=950)  (BBC(I,ISYS),I=1,NOBC(ISYS))
      END IF
 2100 FORMAT(10X,7F10.0) 
      IF(LIST(2).EQ.0)   WRITE(OUT,2200)  ((IBC(J,I,ISYS),J=1,3),
     .     BBC(I,ISYS),I=1,NOBC(ISYS))
 2200 FORMAT(4(5X,3I4,E13.3))

      DO 75 I=1,NOBC(ISYS)
        BBC(I,ISYS) = SCALBC(ISYS)*BBC(I,ISYS) 
   75 CONTINUE

      GO TO 200

C        STANDARD LEVELS
  100 NBCRD = NOBC(ISYS)/NLAYR
      IF(LIST(2).EQ.0)  WRITE(OUT,3100)   (I,I=1,10)
 3100 FORMAT(/43X,'CONCENTRATIONS AT STANDARD LEVELS'/
     .   2X,'ROW COL',8X,10(I2,8X))
      JBC = 0
      DO 135 I=1,NBCRD
        IROW = IBC(1,NLAYR*(I-1)+1,ISYS)
        ICOL = IBC(2,NLAYR*(I-1)+1,ISYS)
        IF (IBNRYRDOPTS(1).EQ.0) THEN
        READ(21,1100)  (SLBC(J),J=1,NOBCSL(I,ISYS))
        ELSE
        READ(21)  (SLBC(J),J=1,NOBCSL(I,ISYS))
        END IF
 1100   FORMAT(10X,7F10.0) 
        IF(LIST(2).EQ.0)   WRITE(OUT,3200)  IROW,ICOL,
     .          (SLBC(J),J=1,NOBCSL(I,ISYS))
 3200   FORMAT(1X,2I4,2X,10E10.3)

        DO 125 IL=1,NLAYR
          SIGDEPTH(IL) = -ZZ(IL)*H(IROW,ICOL)
  125   CONTINUE

        CALL SINTER(SLDEPTH(1,ISYS),SLBC,SIGDEPTH,SIGBC
     .     ,NOBCSL(I,ISYS),NLAYR)
        DO 130 IL=1,NLAYR
          JBC = JBC + 1
          BBC(JBC,ISYS) = SCALBC(ISYS)*SIGBC(IL)
  130   CONTINUE
  135 CONTINUE

      IF(LIST(2).EQ.0)  WRITE(OUT,3300) 
 3300 FORMAT(//30X,'BOUNDARY CONCENTRATIONS AFTER TRANSFORMATION TO SIGM
     .A-LEVELS'/)
      IF(LIST(2).EQ.0)  WRITE(OUT,1700) 
 1700 FORMAT(12X,4(8X,'BC  ROW COL LYR ')) 
      IF(LIST(2).EQ.0)  WRITE(OUT,1900)  (BBC(I,ISYS),(IBC(J,I,ISYS),
     .   J=1,3),I=1,NOBC(ISYS))
 1900 FORMAT(11X,E12.4,3I4,E12.4,3I4,E12.4,3I4,E12.4,3I4)

  200 CONTINUE

      IF(IBCPLOPT.EQ.0)  GO TO 250

C        CALCULATE SLOPES FOR PIECEWISE LINEAR BC OPTION

      DO 230 ISYS=1,NOSYS
        IF(NOBC(ISYS).EQ.0)  GO TO 230
        DO 215 I=1,NOBC(ISYS)
          SBC(I,ISYS) = (SBC(I,ISYS)-BBC(I,ISYS))/(OLDBCT-NXBCT)
  215   CONTINUE
  230 CONTINUE

      OLDBCT = NXBCT

C        MOVE BOUNDARY CONDITIONS TO -CARAY-

  250 DO 300 ISYS=1,NOSYS
      IF(NOBC(ISYS).EQ.0)  GO TO 300

      DO 275 I=1,NOBC(ISYS)
       CARAY(IBC(1,I,ISYS),IBC(2,I,ISYS),IBC(3,I,ISYS),ISYS)=
     .                      (TIME-NXBCT)*SBC(I,ISYS) + BBC(I,ISYS)
  275 CONTINUE
  300 CONTINUE

      IF(IBCPLOPT.EQ.0)  THEN
        IF (IBNRYRDOPTS(1).EQ.0) THEN
        READ(21,1100,ERR=950)  NXBCT
        ELSE
        READ(21,ERR=950)  NXBCT
        END IF
      ENDIF

      RETURN

  950 IN=21
      CALL FMTER
      CALL EXIT 
      END 
