      SUBROUTINE  RCAEXP1
C 
C        RCAEXP1 SETS UP THE -DIAG- AND -AVECT- VECTORS
C                 IF SMOLARKIEWICZ CORRECTION THEN -DIAG- AND -AVECT-
C                 CONTAIN JUST ADVECTIVE TERMS
C                 IF NO SMOLARKIEWICZ CORRECTION THEN -DIAG- AND -AVECT-
C                 CONTAIN ADVECTIVE AND HORIZONTAL DISPERSIVE TERMS
C 
      INCLUDE  'RCACM'

      DO 100 IT=1,6
      DO 100 IL=0,NLAYR+1
      DO 100 IC=1,NCOL
      DO 100 IR=1,NROW
        AVECT(IR,IC,IL,IT) = 0.
 100  CONTINUE

      DO 110 IL=1,NLAYR
      DO 110 IC=1,NCOL
      DO 110 IR=1,NROW
        DIAG(IR,IC,IL) = 0.
 110  CONTINUE

C        CHECK FOR SMOLARKIEWICZ OPTION
      IF(INTGRTYP.LT.4) THEN
       IF(NLAYR.GT.1) THEN
        DO 150 IL=1,NLAYR
          DO 150 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 150 IR=IS,IE
              IF (FSM(IR,IC).LE.0.0)  GO TO 150
              IF (FSM(IR-1,IC).NE.0.0) AVECT(IR,IC,IL,1)=RX(IR,IC,IL)
              IF (FSM(IR+1,IC).NE.0.0) AVECT(IR,IC,IL,2)=RX(IR+1,IC,IL)
              IF (FSM(IR,IC-1).NE.0.0) AVECT(IR,IC,IL,3)=RY(IR,IC,IL)
              IF (FSM(IR,IC+1).NE.0.0) AVECT(IR,IC,IL,4)=RY(IR,IC+1,IL)
              DIAG(IR,IC,IL)=0.0
              IF (FSM(IR-1,IC).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                                RX(IR,IC,IL)
              IF (FSM(IR+1,IC).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                                RX(IR+1,IC,IL)
              IF (FSM(IR,IC-1).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                                RY(IR,IC,IL)
              IF (FSM(IR,IC+1).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                                RY(IR,IC+1,IL)
 150    CONTINUE
       ELSE
        IL=1
        DO 160 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 160 IR=IS,IE
            IF (FSM(IR,IC).LE.0.0)  GO TO 160
            IF (FSM(IR-1,IC).NE.0.0) AVECT(IR,IC,IL,1)=RX(IR,IC,IL)
            IF (FSM(IR+1,IC).NE.0.0) AVECT(IR,IC,IL,2)=RX(IR+1,IC,IL)
            IF (FSM(IR,IC-1).NE.0.0) AVECT(IR,IC,IL,3)=RY(IR,IC,IL)
            IF (FSM(IR,IC+1).NE.0.0) AVECT(IR,IC,IL,4)=RY(IR,IC+1,IL)
            DIAG(IR,IC,IL)=0.0
            IF (FSM(IR-1,IC).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                              RX(IR,IC,IL)
            IF (FSM(IR+1,IC).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                              RX(IR+1,IC,IL)
            IF (FSM(IR,IC-1).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                              RY(IR,IC,IL)
            IF (FSM(IR,IC+1).NE.0.0) DIAG(IR,IC,IL)=DIAG(IR,IC,IL)+
     +                                              RY(IR,IC+1,IL)
 160    CONTINUE
       ENDIF
      ENDIF
C
      DO 200 IL=1,NLAYR
        DO 200 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 200 IR=IS,IE

      IF (FSM(IR,IC).LE.0.0)  GO TO 200

      IF(QX(IR,IC,IL).GT.0.)  THEN
         AVECT(IR,IC,IL,1) = AVECT(IR,IC,IL,1) + QX(IR,IC,IL)
      ELSE
         DIAG(IR,IC,IL) = DIAG(IR,IC,IL) - QX(IR,IC,IL)
      ENDIF

      IF(QX(IR+1,IC,IL).GT.0.)  THEN
         DIAG(IR,IC,IL) = DIAG(IR,IC,IL) + QX(IR+1,IC,IL)
      ELSE
         AVECT(IR,IC,IL,2) = AVECT(IR,IC,IL,2) - QX(IR+1,IC,IL)
      ENDIF

      IF(QY(IR,IC,IL).GT.0.)  THEN
         AVECT(IR,IC,IL,3) = AVECT(IR,IC,IL,3) + QY(IR,IC,IL)
      ELSE
         DIAG(IR,IC,IL) = DIAG(IR,IC,IL) - QY(IR,IC,IL)
      ENDIF

      IF(QY(IR,IC+1,IL).GT.0.)  THEN
         DIAG(IR,IC,IL) = DIAG(IR,IC,IL) + QY(IR,IC+1,IL)
      ELSE
         AVECT(IR,IC,IL,4) = AVECT(IR,IC,IL,4) - QY(IR,IC+1,IL)
      ENDIF

      IF (NLAYR.EQ.1)  GO TO 200

      IF(QZ(IR,IC,IL).GT.0.)  THEN
         DIAG(IR,IC,IL) = DIAG(IR,IC,IL) + QZ(IR,IC,IL)
      ELSE
         AVECT(IR,IC,IL,5) = AVECT(IR,IC,IL,5) - QZ(IR,IC,IL)
      ENDIF

      IF(QZ(IR,IC,IL+1).GT.0.)  THEN
         AVECT(IR,IC,IL,6) = AVECT(IR,IC,IL,6) + QZ(IR,IC,IL+1)
      ELSE
         DIAG(IR,IC,IL) = DIAG(IR,IC,IL) - QZ(IR,IC,IL+1)
      ENDIF

  200 CONTINUE
C
C         ZERO TRANSPORT TERMS FOR BOUNDARY SEGMENTS
C
      DO 210 I=1,NOBCALL
        IR = IBCALL(1,I)
        IC = IBCALL(2,I)
        IL = IBCALL(3,I)
        DIAG(IR,IC,IL) = 0.0
        DO 220 IT=1,6
          AVECT(IR,IC,IL,IT) = 0.0
  220   CONTINUE
  210 CONTINUE
 
      RETURN
      END
