      SUBROUTINE RCASPLTS
C 
C        RCASPLTS IS THE MASTER SUBROUTINE USED FOR INTEGRATING THE
C                 DIFFERENTIAL EQUATIONS OF THE WATER QUALITY MODEL.
C                 TIME DERIVATIVE: EXPLICIT - SPLIT TIMESTEP
C                 SPACE DERIVATIVE: UPWIND WITH SMOLARKIEWICZ CORRECTOR
C
C
C************************************************************************
C 
      INCLUDE 'RCACM' 
      INTEGER  NEGSEG(99,3)
      REAL   CONCS(NROW,NCOL,0:NLAYR),CDARAYS(NROW,NCOL,NLAYR,NOSYS)
     .      ,DM(NROW,NCOL,NLAYR,NOSYS),BVOLN(NROW,NCOL,NLAYR)
     .      ,bvolnt(NROW,NCOL,NLAYR,nosys)
     .      ,D(NROW,NCOL),MF(NROW,NCOL,NLAYR)
     .      ,DXBAR1(NROW,NCOL),DYBAR2(NROW,NCOL)
     .      ,DXBAR2(NROW,NCOL),DYBAR1(NROW,NCOL)
     .      ,FLUXIN(NROW,NCOL,NLAYR),FLUXOUT(NROW,NCOL,NLAYR)
     .      ,U(NROW,NCOL,NLAYR),V(NROW,NCOL,NLAYR),W(NROW,NCOL,NLAYR)
     .      ,USPLT(MXSEGSPLT,2),VSPLT(MXSEGSPLT,2),WSPLT(MXSEGSPLT,2)
     .      ,QXSPLT(MXSEGSPLT,2),QYSPLT(MXSEGSPLT,2),QZSPLT(MXSEGSPLT,2)
     .      ,RXSPLT(MXSEGSPLT,2),RYSPLT(MXSEGSPLT,2)
     .      ,ANTIQX(NROW,NCOL,NLAYR),ANTIQY(NROW,NCOL,NLAYR)
     .      ,ANTIQZ(NROW,NCOL,NLAYR),QXFLX(NROW,NCOL,NLAYR)
     .      ,QYFLX(NROW,NCOL,NLAYR),QZFLX(NROW,NCOL,NLAYR)
     .      ,RXFLX(NROW,NCOL,NLAYR),RYFLX(NROW,NCOL,NLAYR)
     .      ,AL(NROW,NCOL,NLAYR),AD(NROW,NCOL,NLAYR),AU(NROW,NCOL,NLAYR)
     .      ,BETA(NROW,NCOL,NLAYR),GAMMA(NROW,NCOL,NLAYR)

c      EQUIVALENCE
c     .       (MF(1,1,1),SCRATCH_TRAN(1,1,1,2))
c     .    ,  (AL(1,1,1),SCRATCH_TRAN(1,1,1,3))
c     .    ,  (AD(1,1,1),SCRATCH_TRAN(1,1,1,4))
c     .    ,  (AU(1,1,1),SCRATCH_TRAN(1,1,1,5))
c     .    ,  (BETA(1,1,1),SCRATCH_TRAN(1,1,1,6))
c     .    ,  (GAMMA(1,1,1),SCRATCH_TRAN(1,1,1,7))
 
c      EQUIVALENCE
c     .        (BVOLN(1,1,1),SCRATCH_TRAN(1,1,1,8))
c     .      , (ANTIQX(1,1,1),SCRATCH_TRAN(1,1,1,9))
c     .      , (ANTIQY(1,1,1),SCRATCH_TRAN(1,1,1,10))
c     .      , (ANTIQZ(1,1,1),SCRATCH_TRAN(1,1,1,11))
c     .      , (QXFLX(1,1,1),SCRATCH_TRAN(1,1,1,12))
c     .      , (QYFLX(1,1,1),SCRATCH_TRAN(1,1,1,13))
c     .      , (QZFLX(1,1,1),SCRATCH_TRAN(1,1,1,14))
 

C        INITIALIZATION


      ITRAK=1 
      TIME=0.0 
      TIMEWQ=0.0 
      INITB=0
      NSPLIT = DTFULL/DTSPLIT
      DTSTEP = DTFULL
      DTFULL = DTFULL*SCALT
      DT = DTFULL
      DTSPLIT = DT/NSPLIT
      DTWQ=DTWQ*SCALT

      NNG=1
      NND=1
      R=1.E-15

      IF(TZERO.NE.0.)   THEN
         CALL RCA08
         TIME = TZERO
         NNG=TIME/PRNTG+0.5
         IF (PRNTD.NE.0.0) NND=TIME/PRNTD+0.5
      ENDIF


      DO 20 IL=1,NLAYR
        DO 20 IC=1,NCOL
          DO 20 IR=1,NROW
            CONCS(IR,IC,IL) = 0.0
            ANTIQX(IR,IC,IL) = 0.0
            ANTIQY(IR,IC,IL) = 0.0
            ANTIQZ(IR,IC,IL) = 0.0
            QXFLX(IR,IC,IL) = 0.0
            RXFLX(IR,IC,IL) = 0.0
            QYFLX(IR,IC,IL) = 0.0
            RYFLX(IR,IC,IL) = 0.0
            QZFLX(IR,IC,IL) = 0.0
            U(IR,IC,IL) = 0.0
            V(IR,IC,IL) = 0.0
            W(IR,IC,IL) = 0.0
            D(IR,IC) = 0.0
   20 CONTINUE

C        SET UP -AVECT- ARRAYS FOR TIME = 0.0 (TZERO)
  
      CALL RCASPLT1

c$doacross local(iseg,il,ic,ir)
      DO 30 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        RXSPLT(ISEG,1) = RX(IR,IC,IL)
        RXSPLT(ISEG,2) = RX(IR+1,IC,IL)
        RYSPLT(ISEG,1) = RY(IR,IC,IL)
        RYSPLT(ISEG,2) = RY(IR,IC+1,IL)
   30 CONTINUE

c$doacross local(iseg,il,ic,ir)
      DO 35 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        RX(IR,IC,IL) = 0.0
        RX(IR+1,IC,IL) = 0.0
        RY(IR,IC,IL) = 0.0
        RY(IR,IC+1,IL) = 0.0
   35 CONTINUE

C        PRINT INITIAL CONDITIONS

      CALL RCA09
      IDISK = 3 
 
   40 CONTINUE

C        IF PIECEWISE LINEAR BOUNDARY CONDITIONS THEN
C           GET CONCENTRATIONS AT CURRENT TIME LEVEL

      IF(IBCPLOPT.EQ.1)   THEN
c$doacross local(isys,deltbc,il,ic,ir,i)
        DO 50 ISYS=1,NOSYS
          IF(NOBC(ISYS).EQ.0)  GO TO 50
          DELTBC = TIME - NXBCT
          DO 45 I=1,NOBC(ISYS)
            IR=IBC(1,I,ISYS)
            IC=IBC(2,I,ISYS)
            IL=IBC(3,I,ISYS)
            CARAY(IR,IC,IL,ISYS) = DELTBC*SBC(I,ISYS) + BBC(I,ISYS)
   45     CONTINUE
   50  CONTINUE
      ENDIF

C        EVALUATE KINETIC DERIVATIVES 
      IF (DTWQ.EQ.0.0.OR.TIME.GE.TIMEWQ.OR.IDISK.EQ.3) THEN
        CALL TUNER
        IDISK = 0 
        TIMEWQ=TIMEWQ+DTWQ
        INITB = 1 
        ICHANGE = 1
      ENDIF

C        IF TUNER CALLED OR IF LOADS CHANGED THEN UPDATE -CDARAYS-
      IF(ICHANGE.EQ.1)  THEN

c$doacross local(isys,il,ic,ir,is,ie,i),share(cdarays)
       DO 80 ISYS=1,NOSYS

C      SOURCES/SINKS DUE TO KINETICS

        DO 55 IL=1,NLAYR
         DO 55 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 55 IR=IS,IE
            CDARAYS(IR,IC,IL,ISYS) = CDARAY(IR,IC,IL,ISYS)
  55    CONTINUE
 
C  ADD LOADS

        IF(NOPS(ISYS).GT.0)  THEN
          DO 60 I=1,NOPS(ISYS) 
           IR = IPS(1,I,ISYS)
           IC = IPS(2,I,ISYS)
           IL = IPS(3,I,ISYS)
           CDARAYS(IR,IC,IL,ISYS) = CDARAYS(IR,IC,IL,ISYS)+BPS(I,ISYS)
   60     CONTINUE
        ENDIF

        IF(NONPS(ISYS).GT.0)   THEN
          DO 65 I=1,NONPS(ISYS)
           IR = INPS(1,I,ISYS)
           IC = INPS(2,I,ISYS)
           IL = INPS(3,I,ISYS)
           CDARAYS(IR,IC,IL,ISYS) = CDARAYS(IR,IC,IL,ISYS)+BNPS(I,ISYS)
   65     CONTINUE
        ENDIF


        IF(NOFL(ISYS).GT.0)   THEN
          DO 70 I=1,NOFL(ISYS)
           IR = IFL(1,I,ISYS)
           IC = IFL(2,I,ISYS)
           IL = IFL(3,I,ISYS)
           CDARAYS(IR,IC,IL,ISYS) = CDARAYS(IR,IC,IL,ISYS)+BFL(I,ISYS)
   70     CONTINUE
        ENDIF

  
        IF(NOATM(ISYS).GT.0)   THEN
          DO 75 IC=2,NCOL-1
           IS = IRS(IC)
           IE = IRE(IC)
           DO 75 IR=IS,IE
            CDARAYS(IR,IC,1,ISYS) = CDARAYS(IR,IC,1,ISYS)
     .                                   + BATM(ISYS)*XAZ(IR,IC)
   75     CONTINUE
        ENDIF

   80  CONTINUE
       ICHANGE = 0
      ENDIF

C        CALCULATE INITIAL DEPTHS

      DELT = SCALT*(TIME-HYDBRK(ITIMHYD-1))
c$doacross local(ic,ir)
      DO 85 IC=1,NCOL
       DO 85 IR=1,NROW
        D(IR,IC) = H(IR,IC)+ETA(IR,IC)+DELT*DETA(IR,IC)*86400.
   85 CONTINUE

C  CALCULATE CONSTANTS
c$doacross local(ic,ir),share(dxbar1,dxbar2,dybar1,dybar2)
      DO 90 IC=2,NCOL
        DO 90 IR=2,NROW
          DXBAR1(IR,IC) = 0.5*(DX(IR,IC)+DX(IR-1,IC))
          DXBAR2(IR,IC) = 0.5*(DX(IR,IC)+DX(IR,IC-1))
          DYBAR1(IR,IC) = 0.5*(DY(IR,IC)+DY(IR-1,IC))
          DYBAR2(IR,IC) = 0.5*(DY(IR,IC)+DY(IR,IC-1))
   90 CONTINUE

c$doacross local(ic,ir,il)
      DO 95 IL=1,NLAYR
        DO 95 IC=2,NCOL
        DO 95 IR=2,NROW
            U(IR,IC,IL)=QX(IR,IC,IL)/
     .         (DZ(IL)*0.5*(D(IR,IC)+D(IR-1,IC))*DYBAR1(IR,IC))
            V(IR,IC,IL)=QY(IR,IC,IL)/
     .         (DZ(IL)*0.5*(D(IR,IC)+D(IR,IC-1))*DXBAR2(IR,IC))
            W(IR,IC,IL)=QZ(IR,IC,IL)/XAZ(IR,IC)
   95 CONTINUE

      DO 100 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        USPLT(ISEG,1) = U(IR,IC,IL)
        USPLT(ISEG,2) = U(IR+1,IC,IL)
        VSPLT(ISEG,1) = V(IR,IC,IL)
        VSPLT(ISEG,2) = V(IR,IC+1,IL)
        WSPLT(ISEG,1) = W(IR,IC,IL)
        IF(IL.LT.NLAYR)  THEN
          WSPLT(ISEG,2) = W(IR,IC,IL+1)
        ELSE
          WSPLT(ISEG,2) = 0.0
        ENDIF
  100 CONTINUE

      DO 105 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        U(IR,IC,IL) = 0.0
        U(IR+1,IC,IL) = 0.0
        V(IR,IC,IL) = 0.0
        V(IR,IC+1,IL) = 0.0
        W(IR,IC,IL) = 0.0
        IF(IL.LT.NLAYR)  W(IR,IC,IL+1) = 0.0
  105 CONTINUE

C        EULER INTEGRATION STEP

c$doacross local(isys,il,ic,ir),share(dm)
      DO 110 ISYS=1,NOSYS
      DO 110 IL=1,NLAYR
        DO 110 IC=1,NCOL
          DO 110 IR=1,NROW
            DM(IR,IC,IL,ISYS) = 0.0
  110 CONTINUE
      

      IF(NSEGSPLT.EQ.0)  GO TO 200

C     PERFORM SPLIT TIMESTEP COMPUTATION
C        FIRST INTEGRATING CRITICAL TIMESTEP SEGMENTS

c$doacross local(isys,isplit,iseg,il,ic,ir,is,ie,inegs,aa,fmax,fmin,
c$&              totmas,concs,dmsplt,qxsplt,antiqxsplt,fluxin,fluxout,
c$&              qysplt,antiqysplt,qzsplt,antiqzsplt,
c$&              rxflx1,rxflx2,ryflx1,ryflx2), 
c$&              mp_schedtype=dynamic, chunk=1

      DO 190 ISYS=1,NOSYS 

          DO  IL=1,NLAYR
            DO  IC=1,NCOL
              DO  IR=1,NROW
                CONCS(IR,IC,IL) = 0.0
                BVOLN(IR,IC,IL) = 0.0
                ANTIQX(IR,IC,IL) = 0.0
                ANTIQY(IR,IC,IL) = 0.0
                ANTIQZ(IR,IC,IL) = 0.0
                QXFLX(IR,IC,IL) = 0.0
                RXFLX(IR,IC,IL) = 0.0
                QYFLX(IR,IC,IL) = 0.0
                RYFLX(IR,IC,IL) = 0.0
                QZFLX(IR,IC,IL) = 0.0
              ENDDO
            ENDDO
          ENDDO


C        CHECK FOR SYSTEM BYPASS

      IF(SYSBY(ISYS).EQ.1)   GO TO 190

      INEGS=0
      TOTMAS=0.0
      DO 115 IL=1,NLAYR
        DO 115 IC=1,NCOL
          IS = IRS(IC)
          IE = IRE(IC)
          DO 115 IR=IS,IE
            CONCS(IR,IC,IL) = CARAY(IR,IC,IL,ISYS)
  115 CONTINUE
      
      DO 180 ISPLIT=1,NSPLIT

        DO 120 ISEG=1,NSEGSPLT
          IR = ISEGSPLT(ISEG,1)
          IC = ISEGSPLT(ISEG,2)
          IL = ISEGSPLT(ISEG,3)

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'

          BVOLNt(IR,IC,IL,isys) = BVOL(IR,IC,IL)
     .                         + ISPLIT*DTSPLIT*VDERSPLT(ISEG)

C        COMPUTE CHANGE IN MASS FOR CRITICAL SEGMENT

          DMSPLT = CDARAYS(IR,IC,IL,ISYS)
     .        - DIAGSPLT(ISEG)*CARAY(IR,IC,IL,ISYS)
     .         + AVECTSPLT(ISEG,1)*CARAY(IR-1,IC,IL,ISYS)
     .          + AVECTSPLT(ISEG,2)*CARAY(IR+1,IC,IL,ISYS)
     .           + AVECTSPLT(ISEG,3)*CARAY(IR,IC-1,IL,ISYS)
     .            + AVECTSPLT(ISEG,4)*CARAY(IR,IC+1,IL,ISYS)

          IF(IL.GT.1)   
     .      DMSPLT = DMSPLT + AVECTSPLT(ISEG,5)*CARAY(IR,IC,IL-1,ISYS)

          IF(IL.LT.NLAYR)   
     .      DMSPLT = DMSPLT + AVECTSPLT(ISEG,6)*CARAY(IR,IC,IL+1,ISYS)

C        COMPUTE CHANGE IN MASS IN SEGMENTS ADJOINING CRITICAL SEGMENT

            DM(IR-1,IC,IL,ISYS) = DM(IR-1,IC,IL,ISYS) +
     .         AVECTSPLT(ISEG,7)*CARAY(IR,IC,IL,ISYS)/NSPLIT

            DM(IR+1,IC,IL,ISYS) = DM(IR+1,IC,IL,ISYS) +
     .         AVECTSPLT(ISEG,8)*CARAY(IR,IC,IL,ISYS)/NSPLIT

            DM(IR,IC-1,IL,ISYS) = DM(IR,IC-1,IL,ISYS) +
     .         AVECTSPLT(ISEG,9)*CARAY(IR,IC,IL,ISYS)/NSPLIT

            DM(IR,IC+1,IL,ISYS) = DM(IR,IC+1,IL,ISYS) +
     .         AVECTSPLT(ISEG,10)*CARAY(IR,IC,IL,ISYS)/NSPLIT

            IF(IL.GT.1)  DM(IR,IC,IL-1,ISYS) = DM(IR,IC,IL-1,ISYS) +
     .         AVECTSPLT(ISEG,11)*CARAY(IR,IC,IL,ISYS)/NSPLIT

            IF(IL.LT.NLAYR)  DM(IR,IC,IL+1,ISYS) = DM(IR,IC,IL+1,ISYS) +
     .         AVECTSPLT(ISEG,12)*CARAY(IR,IC,IL,ISYS)/NSPLIT

C        NOW COMPUTE CHANGE IN CONCENTRATION FOR CRITICAL SEGMENT

            CONCS(IR,IC,IL) = ((BVOL(IR,IC,IL)+(ISPLIT-1)*DTSPLIT
     .           *VDERSPLT(ISEG))*CARAY(IR,IC,IL,ISYS) + DTSPLIT*DMSPLT)
     .                  /BVOLNt(IR,IC,IL,isys)

C        PREVENT NEGATIVE SOLUTIONS
            IF(CONCS(IR,IC,IL).LT.0.0)
     .           CONCS(IR,IC,IL) = CARAY(IR,IC,IL,ISYS)/4.
  
  120     CONTINUE


C******************************************************************

C  SMOLARKIEWICZ METHOD FOR SECOND-ORDER ACCURACY

C        CALCULATE ANTIDIFFUSIION FLOWS ( = VELOCITIES * AREAS)
C        AND THEN CALCULATE ANTIDIFFUSION FLUXES

      IF(ISMOLAR .GE. 0) THEN
 
C        COMPUTE FOR I,J,K INTERFACES


      DO 125 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)

          IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .            CONCS(IR-1,IC,IL).LE.1.0E-09)  THEN
             QXSPLT(ISEG,1) = 0.0
          ELSE IF(ABS(USPLT(ISEG,1)).LT.(USPLT(ISEG,1)*USPLT(ISEG,1)*
     .               DTSPLIT/DXBAR1(IR,IC)))   THEN
             QXSPLT(ISEG,1) = 0.0
          ELSE
            IF(FSM(IR-1,IC).EQ.1.) THEN
              ANTIQXSPLT = ABS(USPLT(ISEG,1))*
     .          (1.-ABS(USPLT(ISEG,1))*DTSPLIT/DXBAR1(IR,IC))*
     .               (CONCS(IR,IC,IL)-CONCS(IR-1,IC,IL))/
     .                    (CONCS(IR,IC,IL)+CONCS(IR-1,IC,IL)+R)
              QXSPLT(ISEG,1) = 0.5*
     .              (ANTIQXSPLT*(CONCS(IR,IC,IL)+CONCS(IR-1,IC,IL))
     .          -ABS(ANTIQXSPLT)*(CONCS(IR,IC,IL)-CONCS(IR-1,IC,IL)))
     .          *DYBAR1(IR,IC)*0.5*(D(IR,IC)+D(IR-1,IC))*DZ(IL)
            ELSE
              QXSPLT(ISEG,1) = 0.0
            ENDIF
          ENDIF


          IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .          CONCS(IR,IC-1,IL).LE.1.0E-09)  THEN
             QYSPLT(ISEG,1) = 0.0
          ELSE IF(ABS(VSPLT(ISEG,1)).LT.(VSPLT(ISEG,1)*VSPLT(ISEG,1)*
     .               DTSPLIT/DYBAR2(IR,IC)))   THEN
             QYSPLT(ISEG,1) = 0.0
          ELSE
            IF(FSM(IR,IC-1).EQ.1.) THEN
              ANTIQYSPLT = ABS(VSPLT(ISEG,1))*
     .          (1.-ABS(VSPLT(ISEG,1))*DTSPLIT/DYBAR2(IR,IC))*
     .               (CONCS(IR,IC,IL)-CONCS(IR,IC-1,IL))/
     .                    (CONCS(IR,IC,IL)+CONCS(IR,IC-1,IL)+R)
              QYSPLT(ISEG,1) = 0.5*
     .              (ANTIQYSPLT*(CONCS(IR,IC,IL)+CONCS(IR,IC-1,IL))
     .          -ABS(ANTIQYSPLT)*(CONCS(IR,IC,IL)-CONCS(IR,IC-1,IL)))
     .          *DXBAR2(IR,IC)*0.5*(D(IR,IC)+D(IR,IC-1))*DZ(IL)
            ELSE
              QYSPLT(ISEG,1) = 0.0
            ENDIF
          ENDIF


        IF(IL.GT.1) THEN
          IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .          CONCS(IR,IC,IL-1).LE.1.0E-09)  THEN
            QZSPLT(ISEG,1) = 0.0
          ELSE IF(ABS(WSPLT(ISEG,1)).LT.(WSPLT(ISEG,1)*WSPLT(ISEG,1)*
     .               DTSPLIT/(D(IR,IC)*DZZ(IL-1))))   THEN
            QZSPLT(ISEG,1) = 0.0
          ELSE
            ANTIQZSPLT = ABS(WSPLT(ISEG,1))*
     .           (1.-ABS(WSPLT(ISEG,1))*DTSPLIT/(D(IR,IC)*DZZ(IL-1)))*
     .             (CONCS(IR,IC,IL-1)-CONCS(IR,IC,IL))/
     .                  (CONCS(IR,IC,IL-1)+CONCS(IR,IC,IL)+R)
            QZSPLT(ISEG,1) = 0.5*
     .            (ANTIQZSPLT*(CONCS(IR,IC,IL-1)+CONCS(IR,IC,IL))
     .        -ABS(ANTIQZSPLT)*(CONCS(IR,IC,IL-1)-CONCS(IR,IC,IL)))
     .         *XAZ(IR,IC)
          ENDIF
        ELSE
          QZSPLT(ISEG,1) = 0.0
        ENDIF

 125  CONTINUE


C        I+1,J+1,K+1 INTERFACES

      DO 130 ISEG=1,NSEGSPLT
       IR = ISEGSPLT(ISEG,1)
       IC = ISEGSPLT(ISEG,2)
       IL = ISEGSPLT(ISEG,3)

        IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .       CONCS(IR+1,IC,IL).LE.1.0E-09)  THEN
          QXSPLT(ISEG,2) = 0.0
        ELSE IF(ABS(USPLT(ISEG,2)).LT.(USPLT(ISEG,2)*USPLT(ISEG,2)*
     .               DTSPLIT/DXBAR1(IR+1,IC)))   THEN
          QXSPLT(ISEG,2) = 0.0
        ELSE
          IF(FSM(IR+1,IC).EQ.1.) THEN
            ANTIQXSPLT = ABS(USPLT(ISEG,2))*
     .         (1.-ABS(USPLT(ISEG,2))*DTSPLIT/DXBAR1(IR+1,IC))*
     .              (CONCS(IR,IC,IL)-CONCS(IR+1,IC,IL))/
     .                   (CONCS(IR,IC,IL)+CONCS(IR+1,IC,IL)+R)
            QXSPLT(ISEG,2) = 0.5*
     .         (ANTIQXSPLT*(CONCS(IR,IC,IL)+CONCS(IR+1,IC,IL)) -
     .      ABS(ANTIQXSPLT)*(CONCS(IR,IC,IL)-CONCS(IR+1,IC,IL)))
     .          *DYBAR1(IR+1,IC)*0.5*(D(IR,IC)+D(IR+1,IC))*DZ(IL)
          ELSE
             QXSPLT(ISEG,2) = 0.0
          ENDIF
        ENDIF


       IF(FSM(IR,IC).LE.0.)  GO TO 130

        IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .       CONCS(IR,IC+1,IL).LE.1.0E-09)  THEN
          QYSPLT(ISEG,2) = 0.0
        ELSE IF(ABS(VSPLT(ISEG,2)).LT.(VSPLT(ISEG,2)*VSPLT(ISEG,2)*
     .               DTSPLIT/DYBAR2(IR,IC+1)))   THEN
          QYSPLT(ISEG,2) = 0.0
        ELSE
          IF(FSM(IR,IC+1).EQ.1.) THEN
            ANTIQYSPLT = ABS(VSPLT(ISEG,2))*
     .         (1.-ABS(VSPLT(ISEG,2))*DTSPLIT/DYBAR2(IR,IC+1))*
     .              (CONCS(IR,IC,IL)-CONCS(IR,IC+1,IL))/
     .                   (CONCS(IR,IC,IL)+CONCS(IR,IC+1,IL)+R)
            QYSPLT(ISEG,2) = 0.5*
     .         (ANTIQYSPLT*(CONCS(IR,IC,IL)+CONCS(IR,IC+1,IL)) -
     .      ABS(ANTIQYSPLT)*(CONCS(IR,IC,IL)-CONCS(IR,IC+1,IL)))      
     .          *DXBAR2(IR,IC+1)*0.5*(D(IR,IC)+D(IR,IC+1))*DZ(IL)
          ELSE
            QYSPLT(ISEG,2) = 0.0
          ENDIF
        ENDIF
 

       IF(IL.LT.NLAYR) THEN
         IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .           CONCS(IR,IC,IL+1).LE.1.0E-09)  THEN
           QZSPLT(ISEG,2) = 0.0
         ELSE IF(ABS(WSPLT(ISEG,2)).LT.(WSPLT(ISEG,2)*WSPLT(ISEG,2)*
     .                DTSPLIT/(D(IR,IC)*DZZ(IL))))   THEN
           QZSPLT(ISEG,2) = 0.0
         ELSE
           ANTIQZSPLT = ABS(WSPLT(ISEG,2))*
     .            (1.-ABS(WSPLT(ISEG,2))*DTSPLIT/(D(IR,IC)*DZZ(IL)))*
     .              (CONCS(IR,IC,IL+1)-CONCS(IR,IC,IL))/
     .                   (CONCS(IR,IC,IL+1)+CONCS(IR,IC,IL)+R)
           QZSPLT(ISEG,2) = 0.5*
     .         (ANTIQZSPLT*(CONCS(IR,IC,IL+1)+CONCS(IR,IC,IL)) -
     .      ABS(ANTIQZSPLT)*(CONCS(IR,IC,IL+1)-CONCS(IR,IC,IL)))
     .          *XAZ(IR,IC)
         ENDIF
       ELSE
         QZSPLT(ISEG,2) = 0.0
       ENDIF


 130  CONTINUE

      ENDIF

C-----------------------------------------------------------------------
C     IF(SCHEME .EQ. 'SMOLAR_R  ') THEN
C     IF(ISMOLAR .EQ. 1) THEN
C     ENDIF
C-----------------------------------------------------------------------

C  TAKE CORRECTOR UPWIND STEP
C    PLACING RESULTS BACK INTO CONCS (NOW AT (N+1))

      DO 135 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        CONCS(IR,IC,IL)=CONCS(IR,IC,IL)
     .     +DTSPLIT*(QXSPLT(ISEG,1)+QXSPLT(ISEG,2)
     .         +QYSPLT(ISEG,1)+QYSPLT(ISEG,2)
     .         +QZSPLT(ISEG,1)+QZSPLT(ISEG,2))/
     .                                     BVOLNt(IR,IC,IL,isys)
        DM(IR-1,IC,IL,ISYS) = DM(IR-1,IC,IL,ISYS)
     .                              - QXSPLT(ISEG,1)/NSPLIT
        DM(IR+1,IC,IL,ISYS) = DM(IR+1,IC,IL,ISYS)
     .                              - QXSPLT(ISEG,2)/NSPLIT
        DM(IR,IC-1,IL,ISYS) = DM(IR,IC-1,IL,ISYS)
     .                              - QYSPLT(ISEG,1)/NSPLIT
        DM(IR,IC+1,IL,ISYS) = DM(IR,IC+1,IL,ISYS)
     .                              - QYSPLT(ISEG,2)/NSPLIT
        IF(IL.GT.1)  THEN
          DM(IR,IC,IL-1,ISYS) = DM(IR,IC,IL-1,ISYS)
     .                              - QZSPLT(ISEG,1)/NSPLIT
        ENDIF
        IF(IL.LT.NLAYR)  THEN
          DM(IR,IC,IL+1,ISYS) = DM(IR,IC,IL+1,ISYS)
     .                              - QZSPLT(ISEG,2)/NSPLIT
        ENDIF

  135 CONTINUE


C  CALCULATE HORIZONTAL DIFFUSION FLUXES
C    AND THEN CHANGE IN CONCENTRATIONS DUE TO HORIZONTAL DIFFUSION

      DO 145 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        RXFLX1 = RXSPLT(ISEG,1)*
     .           (CARAY(IR-1,IC,IL,ISYS)-CARAY(IR,IC,IL,ISYS))
        RXFLX2 = RXSPLT(ISEG,2)*
     .           (CARAY(IR+1,IC,IL,ISYS)-CARAY(IR,IC,IL,ISYS))
        RYFLX1 = RYSPLT(ISEG,1)*
     .           (CARAY(IR,IC-1,IL,ISYS)-CARAY(IR,IC,IL,ISYS))
        RYFLX2 = RYSPLT(ISEG,2)*
     .           (CARAY(IR,IC+1,IL,ISYS)-CARAY(IR,IC,IL,ISYS))

        CONCS(IR,IC,IL) = CONCS(IR,IC,IL) +
     .     DTSPLIT*(RXFLX1+RXFLX2+RYFLX1+RYFLX2)/BVOLNt(IR,IC,IL,isys)
          DM(IR-1,IC,IL,ISYS) = DM(IR-1,IC,IL,ISYS) - RXFLX1/NSPLIT
          DM(IR+1,IC,IL,ISYS) = DM(IR+1,IC,IL,ISYS) - RXFLX2/NSPLIT
          DM(IR,IC-1,IL,ISYS) = DM(IR,IC-1,IL,ISYS) - RYFLX1/NSPLIT
          DM(IR,IC+1,IL,ISYS) = DM(IR,IC+1,IL,ISYS) - RYFLX2/NSPLIT
  145 CONTINUE

C  END OF SMOLARKIEWICZ METHOD

        DO 155 ISEG=1,NSEGSPLT
          IR = ISEGSPLT(ISEG,1)
          IC = ISEGSPLT(ISEG,2)
          IL = ISEGSPLT(ISEG,3)
          CARAY(IR,IC,IL,ISYS) = CONCS(IR,IC,IL)
  155   CONTINUE


  180   CONTINUE

        DO 185 ISEG=1,NSEGSPLT
          IR = ISEGSPLT(ISEG,1)
          IC = ISEGSPLT(ISEG,2)
          IL = ISEGSPLT(ISEG,3)
          DM(IR,IC,IL,ISYS) = 0.0
  185   CONTINUE

  190 CONTINUE

      DO 195 ISEG=1,NSEGSPLT
        IR = ISEGSPLT(ISEG,1)
        IC = ISEGSPLT(ISEG,2)
        IL = ISEGSPLT(ISEG,3)
        BVOL(IR,IC,IL) = BVOLNt(IR,IC,IL,nosys)
  195 CONTINUE

  200 CONTINUE

C        NOW TAKE FULL EXPLICIT STEP FOR REMAINING WATER SEGMENTS

C        COMPUTE VOLUMES AT TIME LEVEL 'N+1'
 
c$doacross local(il,ic,ir)
      DO 210 IL=1,NLAYR
        DO 210 IC=1,NCOL
        DO 210 IR=1,NROW
            BVOLN(IR,IC,IL) = BVOL(IR,IC,IL) + DT*VDER(IR,IC,IL)
 210  CONTINUE

C        UPDATE -DM- TO INCLUDE KINETICS AND LOADS
 
c$doacross local(isys,il,ic,ir,is,ie)
      DO 215 ISYS=1,NOSYS
       DO 215 IL=1,NLAYR
        DO 215 IC=2,NCOL-1
         IS = IRS(IC)
         IE = IRE(IC)
         DO 215 IR=IS,IE
          DM(IR,IC,IL,ISYS) = DM(IR,IC,IL,ISYS)
     .       + (FSM(IR,IC)-FSMSPLT(IR,IC,IL))*CDARAYS(IR,IC,IL,ISYS)
  215 CONTINUE
 

c$doacross local(isys,ic,ir,il,is,ie,i,j,ilyr,aa,fmax,fmin,inegs,totmas,
c$&       concs,antiqx,antiqy,antiqz,qxflx,qyflx,qzflx,fluxin,fluxout,
c$&       rxflx,ryflx,mf,al,ad,au,beta,gamma),share(negseg)
c$&       ,mp_schedtype=dynamic, chunk=1

      DO 500 ISYS=1,NOSYS 

C        CHECK FOR SYSTEM BYPASS

        IF(SYSBY(ISYS).EQ.1)   GO TO 500

        INEGS=0
        TOTMAS=0.0


C  CALCULATE CONCENTRATION:  UPWIND ADVECTIVE FLUXES

       IF (NLAYR.GT.1) THEN
 
C      SURFACE LAYER
         DO 220 IC=2,NCOL-1
           IS = IRS(IC)
           IE = IRE(IC)
           DO 220 IR=IS,IE
             IF(FSM(IR,IC).LE.0.)GO TO 220
             DM(IR,IC,1,ISYS) = DM(IR,IC,1,ISYS)
     .        - DIAG(IR,IC,1)*CARAY(IR,IC,1,ISYS)
     .         + AVECT(IR,IC,1,1)*CARAY(IR-1,IC,1,ISYS)
     .          + AVECT(IR,IC,1,2)*CARAY(IR+1,IC,1,ISYS)
     .           + AVECT(IR,IC,1,3)*CARAY(IR,IC-1,1,ISYS)
     .            + AVECT(IR,IC,1,4)*CARAY(IR,IC+1,1,ISYS)
     .              + AVECT(IR,IC,1,6)*CARAY(IR,IC,2,ISYS)
             CONCS(IR,IC,1) = (BVOL(IR,IC,1)*CARAY(IR,IC,1,ISYS)
     .                          + DT*DM(IR,IC,1,ISYS))/BVOLN(IR,IC,1)
  220   CONTINUE


C      LAYERS 2 TO NLAYR-1

        DO 225 IL=2,NLAYR-1
          DO 225 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 225 IR=IS,IE
              IF(FSM(IR,IC).LE.0.)GO TO 225
              DM(IR,IC,IL,ISYS) = DM(IR,IC,IL,ISYS)
     .         - DIAG(IR,IC,IL)*CARAY(IR,IC,IL,ISYS)
     .          + AVECT(IR,IC,IL,1)*CARAY(IR-1,IC,IL,ISYS)
     .           + AVECT(IR,IC,IL,2)*CARAY(IR+1,IC,IL,ISYS)
     .            + AVECT(IR,IC,IL,3)*CARAY(IR,IC-1,IL,ISYS)
     .             + AVECT(IR,IC,IL,4)*CARAY(IR,IC+1,IL,ISYS)
     .              + AVECT(IR,IC,IL,5)*CARAY(IR,IC,IL-1,ISYS)
     .               + AVECT(IR,IC,IL,6)*CARAY(IR,IC,IL+1,ISYS)
              CONCS(IR,IC,IL) = (BVOL(IR,IC,IL)*CARAY(IR,IC,IL,ISYS)
     .                           + DT*DM(IR,IC,IL,ISYS))/BVOLN(IR,IC,IL)
  225   CONTINUE

C      BOTTOM LAYER

         DO 230 IC=2,NCOL-1
           IS = IRS(IC)
           IE = IRE(IC)
           DO 230 IR=IS,IE
             IF(FSM(IR,IC).LE.0.)GO TO 230
             DM(IR,IC,NLAYR,ISYS) = DM(IR,IC,NLAYR,ISYS)
     .        - DIAG(IR,IC,NLAYR)*CARAY(IR,IC,NLAYR,ISYS)
     .         + AVECT(IR,IC,NLAYR,1)*CARAY(IR-1,IC,NLAYR,ISYS)
     .          + AVECT(IR,IC,NLAYR,2)*CARAY(IR+1,IC,NLAYR,ISYS)
     .           + AVECT(IR,IC,NLAYR,3)*CARAY(IR,IC-1,NLAYR,ISYS)
     .            + AVECT(IR,IC,NLAYR,4)*CARAY(IR,IC+1,NLAYR,ISYS)
     .             + AVECT(IR,IC,NLAYR,5)*CARAY(IR,IC,NLAYR-1,ISYS)
             CONCS(IR,IC,NLAYR) =
     .             (BVOL(IR,IC,NLAYR)*CARAY(IR,IC,NLAYR,ISYS)
     .                   + DT*DM(IR,IC,NLAYR,ISYS))/BVOLN(IR,IC,NLAYR)
  230  CONTINUE
 
       ELSE
 
        IL=1
        DO 231 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 231 IR=IS,IE
             IF(FSM(IR,IC).LE.0.)GO TO 231
             DM(IR,IC,IL,ISYS) = DM(IR,IC,IL,ISYS)
     .        - DIAG(IR,IC,IL)*CARAY(IR,IC,IL,ISYS)
     .         + AVECT(IR,IC,IL,1)*CARAY(IR-1,IC,IL,ISYS)
     .          + AVECT(IR,IC,IL,2)*CARAY(IR+1,IC,IL,ISYS)
     .           + AVECT(IR,IC,IL,3)*CARAY(IR,IC-1,IL,ISYS)
     .            + AVECT(IR,IC,IL,4)*CARAY(IR,IC+1,IL,ISYS)
            CONCS(IR,IC,IL) = (BVOL(IR,IC,IL)*CARAY(IR,IC,IL,ISYS)
     .                         + DT*DM(IR,IC,IL,ISYS))/BVOLN(IR,IC,IL)
  231   CONTINUE

      ENDIF
 

C  BOUNDARY ELEMENTS ARE UNCHANGED

      DO 255 I=1,NOBCALL
        IR=IBCALL(1,I)
        IC=IBCALL(2,I)
        IL=IBCALL(3,I)
        CONCS(IR,IC,IL)=CARAY(IR,IC,IL,ISYS)
  255 CONTINUE

C******************************************************************

C  SMOLARKIEWICZ METHOD FOR SECOND-ORDER ACCURACY

      IF(ISMOLAR .EQ. 0) THEN

        DO 265 IL=1,NLAYR 
          DO 265 IC=1,NCOL
            DO 265 IR=1,NROW
              ANTIQX(IR,IC,IL)=0.0
              ANTIQY(IR,IC,IL)=0.0
              ANTIQZ(IR,IC,IL)=0.0
              QXFLX(IR,IC,IL)=0.0
              QYFLX(IR,IC,IL)=0.0
              QZFLX(IR,IC,IL)=0.0
 265    CONTINUE

C        CALCULATE ANTIDIFFUSIION FLOWS ( = VELOCITIES * AREAS)
 

      DO 280 IL=1,NLAYR
        DO 280 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 280 IR=IS,IE


          IF(FSM(IR,IC).LE.0.)  GO TO 280

            IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .            CONCS(IR-1,IC,IL).LE.1.0E-09)  THEN
               ANTIQX(IR,IC,IL) = 0.0
            ELSE IF(ABS(U(IR,IC,IL)).LT.(U(IR,IC,IL)*U(IR,IC,IL)*
     .                 DT/DXBAR1(IR,IC)))   THEN
               ANTIQX(IR,IC,IL) = 0.0
            ELSE
               ANTIQX(IR,IC,IL) = ABS(U(IR,IC,IL))*
     .          (1.-ABS(U(IR,IC,IL))*DT/DXBAR1(IR,IC))*
     .               (CONCS(IR,IC,IL)-CONCS(IR-1,IC,IL))/
     .                    (CONCS(IR,IC,IL)+CONCS(IR-1,IC,IL)+R)
            ENDIF


          IF(FSM(IR,IC).LE.0.)  GO TO 280

            IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .            CONCS(IR,IC-1,IL).LE.1.0E-09)  THEN
               ANTIQY(IR,IC,IL) = 0.0
            ELSE IF(ABS(V(IR,IC,IL)).LT.(V(IR,IC,IL)*V(IR,IC,IL)*
     .                 DT/DYBAR2(IR,IC)))   THEN
               ANTIQY(IR,IC,IL) = 0.0
            ELSE
               ANTIQY(IR,IC,IL) = ABS(V(IR,IC,IL))*
     .          (1.-ABS(V(IR,IC,IL))*DT/DYBAR2(IR,IC))*
     .               (CONCS(IR,IC,IL)-CONCS(IR,IC-1,IL))/
     .                    (CONCS(IR,IC,IL)+CONCS(IR,IC-1,IL)+R)
            ENDIF


          IF(FSM(IR,IC).GT.0.) THEN
            IF (IL.GT.1) THEN
               IF(CONCS(IR,IC,IL).LE.1.0E-09 .OR.
     .               CONCS(IR,IC,IL-1).LE.1.0E-09)  THEN
                  ANTIQZ(IR,IC,IL) = 0.0
               ELSE IF(ABS(W(IR,IC,IL)).LT.(W(IR,IC,IL)*W(IR,IC,IL)*
     .                    DT/(D(IR,IC)*DZZ(IL-1))))   THEN
                  ANTIQZ(IR,IC,IL) = 0.0
               ELSE
                 ANTIQZ(IR,IC,IL) = ABS(W(IR,IC,IL))*
     .                (1.-ABS(W(IR,IC,IL))*DT/(D(IR,IC)*DZZ(IL-1)))*
     .                  (CONCS(IR,IC,IL-1)-CONCS(IR,IC,IL))/
     .                       (CONCS(IR,IC,IL-1)+CONCS(IR,IC,IL)+R)
               ENDIF
            ENDIF
          ENDIF

 280  CONTINUE

      ENDIF

C-----------------------------------------------------------------------
      IF(ISMOLAR .EQ. 1) THEN

        DO 281 IL=1,NLAYR
        DO 281 IC=2,NCOL-1
        DO 281 IR=2,NROW
          IF(CONCS(IR,IC,IL).LT.1.E-9.OR.CONCS(IR-1,IC,IL).LT.1.E-9)THEN
            ANTIQX(IR,IC,IL)=0.0 
          ELSE
            AA=(CONCS(IR,IC,IL)-CONCS(IR-1,IC,IL))/
     .             (CONCS(IR-1,IC,IL)+CONCS(IR,IC,IL)+1.0E-15)
            ANTIQX(IR,IC,IL)=ABS(U(IR,IC,IL))*AA/(1.-ABS(AA)+1.0E-15) 
          END IF
  281   CONTINUE

        DO 282 IL=1,NLAYR
        DO 282 IC=2,NCOL
        DO 282 IR=2,NROW-1
          IF(CONCS(IR,IC,IL).LT.1.E-9.OR.CONCS(IR,IC-1,IL).LT.1.E-9)THEN
            ANTIQY(IR,IC,IL)=0.0  
          ELSE
            AA=(CONCS(IR,IC,IL)-CONCS(IR,IC-1,IL))/
     .             (CONCS(IR,IC-1,IL)+CONCS(IR,IC,IL)+1.0E-15)
            ANTIQY(IR,IC,IL)=ABS(V(IR,IC,IL))*AA/(1.-ABS(AA)+1.0E-15)  
          END IF
  282   CONTINUE

        DO 283 IL=2,NLAYR
        DO 283 IC=2,NCOL-1
        DO 283 IR=2,NROW-1
          IF(CONCS(IR,IC,IL).LT.1.E-9.OR.CONCS(IR,IC,IL-1).LT.1.E-9)THEN
            ANTIQZ(IR,IC,IL)=0.0 
          ELSE
            AA=(CONCS(IR,IC,IL-1)-CONCS(IR,IC,IL))/
     .             (CONCS(IR,IC,IL)+CONCS(IR,IC,IL-1)+1.0E-15)
            ANTIQZ(IR,IC,IL)=ABS(W(IR,IC,IL))*AA/(1.-ABS(AA)+1.0E-15)
          END IF
  283   CONTINUE

C
C------------- ADJUST FOR RIVER/WALL FLUXES -------------
        DO 284 IL=1,NLAYR
        DO 284 IC=2,NCOL
        DO 284 IR=2,NROW
        IF(FSM(IR,IC).EQ.1..AND.FSM(IR-1,IC).EQ.-1.)ANTIQX(IR,IC,IL)=0.0
        IF(FSM(IR,IC).EQ.-1..AND.FSM(IR-1,IC).EQ.1.)ANTIQX(IR,IC,IL)=0.0
        IF(FSM(IR,IC).EQ.1..AND.FSM(IR,IC-1).EQ.-1.)ANTIQY(IR,IC,IL)=0.0
        IF(FSM(IR,IC).EQ.-1..AND.FSM(IR,IC-1).EQ.1.)ANTIQY(IR,IC,IL)=0.0
  284   CONTINUE


        DO 285 IL=1,NLAYR
        DO 285 IC=1,NCOL
        DO 285 IR=1,NROW
          FLUXIN(IR,IC,IL)=0.0
          FLUXOUT(IR,IC,IL)=0.0
  285   CONTINUE

        DO 286 IL=1,NLAYR
        DO 286 IC=2,NCOL-1
        DO 286 IR=2,NROW-1
          IF(ANTIQX(IR,IC,IL).GE.0.)THEN
            FLUXIN( IR,IC,IL)=FLUXIN(IR,IC,IL)+
     .             ANTIQX(IR,IC,IL)/DXBAR1(IR,IC)*CONCS(IR-1,IC,IL)
          ELSE
            FLUXOUT(IR,IC,IL)=FLUXOUT(IR,IC,IL)-
     .             ANTIQX(IR,IC,IL)/DXBAR1(IR,IC)*CONCS(IR,IC,IL)
          ENDIF
          IF(ANTIQX(IR+1,IC,IL).GE.0.)THEN
            FLUXOUT(IR,IC,IL)=FLUXOUT(IR,IC,IL)+
     .             ANTIQX(IR+1,IC,IL)/DXBAR1(IR+1,IC)*CONCS(IR,IC,IL)
          ELSE
            FLUXIN(IR,IC,IL)=FLUXIN(IR,IC,IL)-
     .             ANTIQX(IR+1,IC,IL)/DXBAR1(IR+1,IC)*CONCS(IR+1,IC,IL)
          ENDIF
  286   CONTINUE

        DO 287 IL=1,NLAYR
        DO 287 IC=2,NCOL-1
        DO 287 IR=2,NROW-1
          IF(ANTIQY(IR,IC,IL).GE.0.)THEN
            FLUXIN(IR,IC,IL)=FLUXIN(IR,IC,IL)+
     .             ANTIQY(IR,IC,IL)/DYBAR2(IR,IC)*CONCS(IR,IC-1,IL)
          ELSE
            FLUXOUT(IR,IC,IL)=FLUXOUT(IR,IC,IL)-
     .             ANTIQY(IR,IC,IL)/DYBAR2(IR,IC)*CONCS(IR,IC,IL)
          ENDIF
          IF(ANTIQY(IR,IC+1,IL).GE.0.)THEN
            FLUXOUT(IR,IC,IL)=FLUXOUT(IR,IC,IL)+
     .             ANTIQY(IR,IC+1,IL)/DYBAR2(IR,IC+1)*CONCS(IR,IC,IL)
          ELSE
            FLUXIN(IR,IC,IL)=FLUXIN(IR,IC,IL)-
     .             ANTIQY(IR,IC+1,IL)/DYBAR2(IR,IC+1)*CONCS(IR,IC+1,IL)
          ENDIF
  287   CONTINUE

      
        DO 288 IC=2,NCOL-1
        DO 288 IR=2,NROW-1
          IF(ANTIQZ(IR,IC,2).GE.0.)THEN
            FLUXIN(IR,IC,1)=FLUXIN(IR,IC,1)+
     .             ANTIQZ(IR,IC,2)/(DZZ(1)*D(IR,IC))*CONCS(IR,IC,2)
          ELSE
            FLUXOUT(IR,IC,1)=FLUXOUT(IR,IC,1)-
     .             ANTIQZ(IR,IC,2)/(DZZ(1)*D(IR,IC))*CONCS(IR,IC,1)
          ENDIF
          IF(ANTIQZ(IR,IC,NLAYR).GE.0.)THEN
           FLUXOUT(IR,IC,NLAYR)=FLUXOUT(IR,IC,NLAYR)+ANTIQZ(IR,IC,NLAYR)
     .                     /(DZZ(NLAYR-1)*D(IR,IC))*CONCS(IR,IC,NLAYR)
          ELSE
            FLUXIN(IR,IC,NLAYR)=FLUXIN(IR,IC,NLAYR)-ANTIQZ(IR,IC,NLAYR)
     .                   /(DZZ(NLAYR-1)*D(IR,IC))*CONCS(IR,IC,NLAYR-1)
          ENDIF
  288   CONTINUE

        DO 289 IL=2,NLAYR-1
        DO 289 IC=2,NCOL-1
        DO 289 IR=2,NROW-1
          IF(ANTIQZ(IR,IC,IL).GE.0.)THEN
            FLUXOUT(IR,IC,IL)=FLUXOUT(IR,IC,IL)+ANTIQZ(IR,IC,IL)
     .                         /(DZZ(IL-1)*D(IR,IC))*CONCS(IR,IC,IL)
          ELSE
            FLUXIN(IR,IC,IL)=FLUXIN(IR,IC,IL)-ANTIQZ(IR,IC,IL)
     .                         /(DZZ(IL-1)*D(IR,IC))*CONCS(IR,IC,IL-1)
          ENDIF
          IF(ANTIQZ(IR,IC,IL+1).GE.0.)THEN
            FLUXIN(IR,IC,IL)=FLUXIN(IR,IC,IL)+ANTIQZ(IR,IC,IL+1)
     .                         /(DZZ(IL)*D(IR,IC))*CONCS(IR,IC,IL+1)
          ELSE
            FLUXOUT(IR,IC,IL)=FLUXOUT(IR,IC,IL)-ANTIQZ(IR,IC,IL+1)
     .                         /(DZZ(IL)*D(IR,IC))*CONCS(IR,IC,IL)
          ENDIF
  289   CONTINUE

C
        DO IL=1,NLAYR 
        DO IC=1,NCOL
        DO IR=1,NROW
          IF(FSM(IR,IC).EQ.0)CARAY(IR,IC,IL,ISYS)=0.0
          IF(FSM(IR,IC).EQ.0)CONCS(IR,IC,IL)=0.0
        ENDDO
        ENDDO
        ENDDO

        DO 291 IL=1,NLAYR 
        DO 291 IC=2,NCOL-1
        DO 291 IR=2,NROW-1
          IF(IL.EQ.1)THEN
            FMAX=AMAX1(CARAY(IR,IC,IL,ISYS),
     .           CARAY(IR-1,IC,IL,ISYS),CARAY(IR+1,IC,IL,ISYS),
     .           CARAY(IR,IC-1,IL,ISYS),CARAY(IR,IC+1,IL,ISYS),
     .           CARAY(IR,IC,IL+1,ISYS),
     .           CONCS(IR,IC,IL),
     .           CONCS(IR-1,IC,IL),CONCS(IR+1,IC,IL),
     .           CONCS(IR,IC-1,IL),CONCS(IR,IC+1,IL),
     .           CONCS(IR,IC,IL+1))
          ELSE
            IF(IL.EQ.NLAYR)THEN
              FMAX=AMAX1(CARAY(IR,IC,IL,ISYS),
     .           CARAY(IR-1,IC,IL,ISYS),CARAY(IR+1,IC,IL,ISYS),
     .           CARAY(IR,IC-1,IL,ISYS),CARAY(IR,IC+1,IL,ISYS),
     .           CARAY(IR,IC,IL-1,ISYS),
     .           CONCS(IR,IC,IL),
     .           CONCS(IR-1,IC,IL),CONCS(IR+1,IC,IL),
     .           CONCS(IR,IC-1,IL),CONCS(IR,IC+1,IL),
     .           CONCS(IR,IC,IL-1))
            ELSE
              FMAX=AMAX1(CARAY(IR,IC,IL,ISYS),
     .           CARAY(IR-1,IC,IL,ISYS),CARAY(IR+1,IC,IL,ISYS),
     .           CARAY(IR,IC-1,IL,ISYS),CARAY(IR,IC+1,IL,ISYS),
     .           CARAY(IR,IC,IL-1,ISYS),CARAY(IR,IC,IL+1,ISYS),
     .           CONCS(IR,IC,IL),
     .           CONCS(IR-1,IC,IL),CONCS(IR+1,IC,IL),
     .           CONCS(IR,IC-1,IL),CONCS(IR,IC+1,IL),
     .           CONCS(IR,IC,IL-1),CONCS(IR,IC,IL+1))
            ENDIF
          ENDIF

          FLUXIN(IR,IC,IL)=(FMAX-CONCS(IR,IC,IL))/
     .                 (DT*FLUXIN(IR,IC,IL)+1.0E-15)
  291   CONTINUE

        DO IL=1,NLAYR 
        DO IC=1,NCOL
        DO IR=1,NROW
          IF(FSM(IR,IC).EQ.0)CARAY(IR,IC,IL,ISYS)=1.E+20
          IF(FSM(IR,IC).EQ.0)CONCS(IR,IC,IL)=1.E+20
        ENDDO
        ENDDO
        ENDDO

        DO 292 IL=1,NLAYR 
        DO 292 IC=2,NCOL-1
        DO 292 IR=2,NROW-1
          IF(IL.EQ.1)THEN
            FMIN=AMIN1(CARAY(IR,IC,IL,ISYS),
     .           CARAY(IR-1,IC,IL,ISYS),CARAY(IR+1,IC,IL,ISYS),
     .           CARAY(IR,IC-1,IL,ISYS),CARAY(IR,IC+1,IL,ISYS),
     .           CARAY(IR,IC,IL+1,ISYS),
     .           CONCS(IR,IC,IL),
     .           CONCS(IR-1,IC,IL),CONCS(IR+1,IC,IL),
     .           CONCS(IR,IC-1,IL),CONCS(IR,IC+1,IL),
     .           CONCS(IR,IC,IL+1))
          ELSE
            IF(IL.EQ.NLAYR)THEN
              FMIN=AMIN1(CARAY(IR,IC,IL,ISYS),
     .           CARAY(IR-1,IC,IL,ISYS),CARAY(IR+1,IC,IL,ISYS),
     .           CARAY(IR,IC-1,IL,ISYS),CARAY(IR,IC+1,IL,ISYS),
     .           CARAY(IR,IC,IL-1,ISYS),
     .           CONCS(IR,IC,IL),
     .           CONCS(IR-1,IC,IL),CONCS(IR+1,IC,IL),
     .           CONCS(IR,IC-1,IL),CONCS(IR,IC+1,IL),
     .           CONCS(IR,IC,IL-1))
            ELSE
              FMIN=AMIN1(CARAY(IR,IC,IL,ISYS),
     .           CARAY(IR-1,IC,IL,ISYS),CARAY(IR+1,IC,IL,ISYS),
     .           CARAY(IR,IC-1,IL,ISYS),CARAY(IR,IC+1,IL,ISYS),
     .           CARAY(IR,IC,IL-1,ISYS),CARAY(IR,IC,IL+1,ISYS),
     .           CONCS(IR,IC,IL),
     .           CONCS(IR-1,IC,IL),CONCS(IR+1,IC,IL),
     .           CONCS(IR,IC-1,IL),CONCS(IR,IC+1,IL),
     .           CONCS(IR,IC,IL-1),CONCS(IR,IC,IL+1))
            ENDIF
          ENDIF

          FLUXOUT(IR,IC,IL)=(CONCS(IR,IC,IL)-FMIN)/
     .                  (DT*FLUXOUT(IR,IC,IL)+1.0E-15)
  292   CONTINUE
 
        DO IL=1,NLAYR 
        DO IC=1,NCOL
        DO IR=1,NROW
          IF(FSM(IR,IC).EQ.0)CARAY(IR,IC,IL,ISYS)=0.0
          IF(FSM(IR,IC).EQ.0)CONCS(IR,IC,IL)=0.0
        ENDDO
        ENDDO
        ENDDO

 
        DO 293 IL=1,NLAYR 
        DO 293 IC=1,NCOL
        DO 293 IR=1,NROW
          IF(FSM(IR,IC).EQ.-1)FLUXIN(IR,IC,IL)=0.
          IF(FSM(IR,IC).EQ.-1)FLUXOUT(IR,IC,IL)=0.
  293   CONTINUE
C
        DO 294 IL=1,NLAYR
        DO 294 IC=2,NCOL
        DO 294 IR=2,NROW
          IF(ANTIQX(IR,IC,IL).GE.0.)THEN
            ANTIQX(IR,IC,IL)=ANTIQX(IR,IC,IL)*
     .            (AMIN1(1.,FLUXIN(IR,IC,IL),FLUXOUT(IR-1,IC,IL)))
          ELSE
            ANTIQX(IR,IC,IL)=ANTIQX(IR,IC,IL)*
     .            (AMIN1(1.,FLUXIN(IR-1,IC,IL),FLUXOUT(IR,IC,IL)))
          ENDIF

          IF(ANTIQY(IR,IC,IL).GE.0.)THEN
            ANTIQY(IR,IC,IL)=ANTIQY(IR,IC,IL)*
     .            (AMIN1(1.,FLUXIN(IR,IC,IL),FLUXOUT(IR,IC-1,IL)))
          ELSE
            ANTIQY(IR,IC,IL)=ANTIQY(IR,IC,IL)*
     .            (AMIN1(1.,FLUXIN(IR,IC-1,IL),FLUXOUT(IR,IC,IL)))
          ENDIF

          IF(IL.GE.2)THEN
            IF(ANTIQZ(IR,IC,IL).GE.0.)THEN
              ANTIQZ(IR,IC,IL)=ANTIQZ(IR,IC,IL)*
     .            (AMIN1(1.,FLUXIN(IR,IC,IL-1),FLUXOUT(IR,IC,IL)))
            ELSE
              ANTIQZ(IR,IC,IL)=ANTIQZ(IR,IC,IL)*
     .            (AMIN1(1.,FLUXIN(IR,IC,IL),FLUXOUT(IR,IC,IL-1)))
            ENDIF
          ENDIF
  294   CONTINUE

      ENDIF

C  CALCULATE ANTIDIFFUSION FLUXES

      DO 310 IL=1,NLAYR
        DO 310 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 310 IR=IS,IE
            IF(FSM(IR,IC).LE.0.)  GO TO 310

            IF(FSM(IR,IC).EQ.1 .AND. FSM(IR-1,IC).EQ.1.)
     .        QXFLX(IR,IC,IL) = 0.5*(ANTIQX(IR,IC,IL)*(CONCS(IR,IC,IL)+
     .           CONCS(IR-1,IC,IL))-ABS(ANTIQX(IR,I C,IL))*
     .           (CONCS(IR,IC,IL)-CONCS(IR-1,IC,IL)))
     .           *DYBAR1(IR,IC)*0.5*(D(IR,IC)+D(IR-1,IC))*DZ(IL)

 
            IF(FSM(IR,IC).LE.0.)  GO TO 310

              IF(FSM(IR,IC).EQ.1 .AND. FSM(IR,IC-1).EQ.1.)
     .        QYFLX(IR,IC,IL) = 0.5*(ANTIQY(IR,IC,IL)*(CONCS(IR,IC,IL)+
     .          CONCS(IR,IC-1,IL))-ABS(ANTIQY(IR,IC,IL))*
     .          (CONCS(IR,IC,IL)-CONCS(IR,IC-1,IL)))      
     .           *DXBAR2(IR,IC)*0.5*(D(IR,IC)+D(IR,IC-1))*DZ(IL)


            IF(NLAYR.GT.1.AND.IL.GT.1.AND.FSM(IR,IC).GT.0.) 
     .        QZFLX(IR,IC,IL) = 0.5*
     .        (ANTIQZ(IR,IC,IL)*(CONCS(IR,IC,IL-1)+CONCS(IR,IC,IL))-
     .          ABS(ANTIQZ(IR,IC,IL))*(CONCS(IR,IC,IL-1)-
     .          CONCS(IR,IC,IL)))*XAZ(IR,IC)


 310  CONTINUE


C  SET HORIZONTAL ANTIDIFFUSION FLUXES IN BOUNDARY ELEMENTS TO ZERO

        DO 325 I=1,NOBCALL
          IR=IBCALL(1,I)
          IC=IBCALL(2,I)
          IL=IBCALL(3,I)
          QXFLX(IR,IC,IL)=0.0
          QXFLX(IR+1,IC,IL)=0.0
          QYFLX(IR,IC,IL)=0.0
          QYFLX(IR,IC+1,IL)=0.0
 325    CONTINUE

C  TAKE UPWIND STEP, PLACING RESULTS BACK INTO CONCS NOW AT (N+1)''

        IF (NLAYR.GT.1) THEN
          DO 330 IL=1,NLAYR-1
            DO 330 IC=2,NCOL-1
              IS = IRS(IC)
              IE = IRE(IC)
              DO 330 IR=IS,IE
                IF(FSM(IR,IC).LE.0.)GO TO 330
                CONCS(IR,IC,IL)=CONCS(IR,IC,IL)
     .             -DT*(QXFLX(IR+1,IC,IL)-QXFLX(IR,IC,IL)
     .                 +QYFLX(IR,IC+1,IL)-QYFLX(IR,IC,IL)
     .                 +QZFLX(IR,IC,IL)-QZFLX(IR,IC,IL+1))/
     .                                             BVOLN(IR,IC,IL)
 330      CONTINUE

          IL=NLAYR
          DO 335 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 335 IR=IS,IE
              IF(FSM(IR,IC).LE.0.)GO TO 335
              CONCS(IR,IC,IL)=CONCS(IR,IC,IL)
     .           -DT*(QXFLX(IR+1,IC,IL)-QXFLX(IR,IC,IL)
     .               +QYFLX(IR,IC+1,IL)-QYFLX(IR,IC,IL)
     .               +QZFLX(IR,IC,IL))/BVOLN(IR,IC,IL)
 335      CONTINUE
        ELSE
          IL=1
          DO 340 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 340 IR=IS,IE
              IF(FSM(IR,IC).LE.0.)GO TO 340
              CONCS(IR,IC,IL)=CONCS(IR,IC,IL)
     .           -DT*(QXFLX(IR+1,IC,IL)-QXFLX(IR,IC,IL)
     .               +QYFLX(IR,IC+1,IL)-QYFLX(IR,IC,IL))/
     .                                             BVOLN(IR,IC,IL)
 340      CONTINUE
        ENDIF


C  CALCULATE HORIZONTAL DIFFUSION FLUXES

        DO 345 IL=1,NLAYR
          DO 345 IC=2,NCOL
          DO 345 IR=2,NROW
              IF(FSM(IR,IC).GE.1. OR. FSM(IR,IC).LE.-2)THEN
                IF(FSM(IR-1,IC).GE.1. OR. FSM(IR-1,IC).LE.-2)THEN
                  RXFLX(IR,IC,IL)=RX(IR,IC,IL)*
     .                 (CARAY(IR-1,IC,IL,ISYS)-CARAY(IR,IC,IL,ISYS))
                ENDIF
                IF(FSM(IR,IC-1).GE.1. OR. FSM(IR,IC-1).LE.-2)THEN
                  RYFLX(IR,IC,IL)=RY(IR,IC,IL)*
     .              (CARAY(IR,IC-1,IL,ISYS)-CARAY(IR,IC,IL,ISYS))
                ENDIF
              ENDIF
 345    CONTINUE

C  CALCULATE CONCENTRATIONS: HORIZONTAL DIFFUSION

        DO 350 IL=1,NLAYR
          DO 350 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 350 IR=IS,IE
              IF(FSM(IR,IC).LE.0.)GO TO 350
              CONCS(IR,IC,IL)=CONCS(IR,IC,IL)+DT*
     +         (RXFLX(IR,IC,IL)-RXFLX(IR+1,IC,IL)+RYFLX(IR,IC,IL)
     +        -RYFLX(IR,IC+1,IL))/BVOLN(IR,IC,IL)
 350    CONTINUE


C  BOUNDARY ELEMENTS ARE UNCHANGED

        DO 355 I=1,NOBCALL
          IR=IBCALL(1,I)
          IC=IBCALL(2,I)
          IL=IBCALL(3,I)
          CONCS(IR,IC,IL)=CARAY(IR,IC,IL,ISYS)
  355   CONTINUE

C  END OF SMOLARKIEWICZ METHOD

C**********************************************************************

C  COMPLETE REST OF INTEGRATION STEP
C        I.E., THE IMPLICIT VERTICAL DIFFUSION STEP  (IF NLAYR > 1)
        IF (NLAYR.EQ.1)  GO TO 400
 
        DO 360 IL=1,NLAYR
         DO 360 IC=2,NCOL-1
          IS = IRS(IC)
          IE = IRE(IC)
          DO 360 IR=IS,IE
            MF(IR,IC,IL) = CONCS(IR,IC,IL)*BVOLN(IR,IC,IL)
 360    CONTINUE

C        SET UP DIAGONAL AND OFF-DIAGONAL ELEMENTS

        DO 370 IC=2,NCOL-1
         IS = IRS(IC)
         IE = IRE(IC)
         DO 370 IR=IS,IE
          IF(FSM(IR,IC).LE.0)  GO TO 370
          AL(IR,IC,1) = 0.
          AD(IR,IC,1) = BVOLN(IR,IC,1) + DT*RZ(IR,IC,2)
          AU(IR,IC,1) = -DT*RZ(IR,IC,2)
           DO 365 IL=2,NLAYR-1
            AL(IR,IC,IL) = -DT*RZ(IR,IC,IL)
            AD(IR,IC,IL) = BVOLN(IR,IC,IL) +
     .                        DT*(RZ(IR,IC,IL) + RZ(IR,IC,IL+1))
            AU(IR,IC,IL) = -DT*RZ(IR,IC,IL+1)
  365      CONTINUE
          AL(IR,IC,NLAYR) = -DT*RZ(IR,IC,NLAYR)
          AD(IR,IC,NLAYR) = BVOLN(IR,IC,NLAYR) + DT*RZ(IR,IC,NLAYR)
          AU(IR,IC,NLAYR) = 0.0
  370   CONTINUE

C        FORWARD SWEEP OF TRIDIAGONAL SCHEME

        DO 380 IC=2,NCOL-1
         IS = IRS(IC)
         IE = IRE(IC)
         DO 380 IR=IS,IE
          IF(FSM(IR,IC).LE.0)  GO TO 380
          BETA(IR,IC,1) = AD(IR,IC,1)
          GAMMA(IR,IC,1) = MF(IR,IC,1)/BETA(IR,IC,1)
          DO 375 IL=2,NLAYR
           BETA(IR,IC,IL) = AD(IR,IC,IL)
     .                 - AL(IR,IC,IL)*AU(IR,IC,IL-1)/BETA(IR,IC,IL-1)
           GAMMA(IR,IC,IL) = (MF(IR,IC,IL)
     .                 - AL(IR,IC,IL)*GAMMA(IR,IC,IL-1))/BETA(IR,IC,IL)
  375     CONTINUE
  380   CONTINUE

C        BACKWARD SWEEP FOR SOLUTION

        DO 390 IC=2,NCOL-1
         IS = IRS(IC)
         IE = IRE(IC)
         DO 390 IR=IS,IE
          IF(FSM(IR,IC).LE.0)  GO TO 390
          CONCS(IR,IC,NLAYR) = GAMMA(IR,IC,NLAYR)
          DO 385 ILYR=2,NLAYR
           IL = NLAYR+1-ILYR
           CONCS(IR,IC,IL) = GAMMA(IR,IC,IL)
     .               - AU(IR,IC,IL)*CONCS(IR,IC,IL+1)/BETA(IR,IC,IL)
  385     CONTINUE
  390   CONTINUE

C  BOUNDARY ELEMENTS ARE UNCHANGED

        DO 395 I=1,NOBCALL
          IR=IBCALL(1,I)
          IC=IBCALL(2,I)
          IL=IBCALL(3,I)
          CONCS(IR,IC,IL)=CARAY(IR,IC,IL,ISYS)
  395   CONTINUE
 

  400   CONTINUE

 
        DO 470 IL=1,NLAYR
          DO 470 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 470 IR=IS,IE
              IF(FSM(IR,IC).LE.0.)GO TO 470
C           DO 470 IR=2,NROW-1
C
C        CHECK TO SEE IF NEGATIVE SOLUTIONS PERMITTED 
C
              IF (NEGSLN.EQ.1)   THEN
                CARAY(IR,IC,IL,ISYS) = CONCS(IR,IC,IL)
              ELSE
C
C        IF NOT ... CHECK TO MAKE SURE SOLUTION IS NOT FORCED THRU ZERO
C
                IF(CONCS(IR,IC,IL).GE.0.0)   THEN
                  CARAY(IR,IC,IL,ISYS) = CONCS(IR,IC,IL)
                ELSE
C
C          PREVENT NEG SOLN BY QUARTERING PRESENT CONC AND PRINT WARNING
C
                  CARAY(IR,IC,IL,ISYS) = CARAY(IR,IC,IL,ISYS)/4.
c$        call mp_setlock
                  INEGS = INEGS+1
                  IF(INEGS.LE.99)  THEN
                    NEGSEG(INEGS,1) = IR
                    NEGSEG(INEGS,2) = IC
                    NEGSEG(INEGS,3) = IL
                  ENDIF
                  TOTMAS = TOTMAS+(CARAY(IR,IC,IL,ISYS)-CONCS(IR,IC,IL))
     +            *BVOLN(IR,IC,IL)
c$        call mp_unsetlock
                ENDIF
              ENDIF
 470    CONTINUE


C       IF(INEGS.GT.0)  THEN
C           call mp_setlock
C         CALL RCAMESS(2,0.001*TOTMAS)
C         WRITE(OUT,1000)  ((NEGSEG(I,J),J=1,3),I=1,INEGS)
C1000     FORMAT(30X,12I5)
C           call mp_unsetlock
C       ENDIF

  500 CONTINUE
C

       DO 515 IL=1,NLAYR
        DO 515 IC=1,NCOL
        DO 515 IR=1,NROW
          BVOL(IR,IC,IL) = BVOLN(IR,IC,IL)
  515 CONTINUE


C  PREPARE FOR NEXT TIME STEP
C
        TIME=TIME + DTSTEP


C        CHECK TO SEE IF IT IS TIME TO PRINT RESULTS

C  FIRST DETAILED DUMPS

      IF(PRNTD.EQ.0.0)  GO TO 535
      EPSLNP = DTSTEP/(PRNTD*2.)
      M=TIME/PRNTD+EPSLNP
      IF(M.LT.NND)  GO TO 535
C
C  DETAILED PRINT TIME
C  SET IDISK FOR DETAILED DUMPS
C     
      IDISK=2
      NND=M+1
C
C  SECOND GLOBAL DUMPS
C
 535  EPSLNP=DTSTEP/(PRNTG*2.)
      M=TIME/PRNTG+EPSLNP
      IF (M.LT.NNG) GOTO 550
C
C  GLOBAL PRINT TIME
C  CALL PRINT ROUTINE
C
      CALL RCA09
      IDISK=IDISK+1
      NNG=M+1 

C      
C  NOW PERFORM STABILITY CHECK
C 
C 
      DO 545 ISYS=1,NOSYS 
        IF(SYSBY(ISYS).EQ.1)   GO TO 545
        CKMAX = CMAX(ISYS)

        DO 540 IL=1,NLAYR
          DO 540 IC=2,NCOL-1
            IS = IRS(IC)
            IE = IRE(IC)
            DO 540 IR=IS,IE
              IF(FSM(IR,IC).LE.0.)GO TO 540
              IF(CARAY(IR,IC,IL,ISYS).GE.CKMAX)   GO TO 600
  540   CONTINUE
  545 CONTINUE
C
C        CHECK TO SEE IF NECESSARY TO UPDATE TIME-VARIABLE FUNCTIONS
C        FIRST POINT SOURCE LOADS 
C
  550 IF(IPSOPT.GT.1.AND.TIME.GE.NXPST)   
     .   CALL RCA10(BPS,NWK,NOPS,NXPST,22,SCALPS)

C        NONPOINT SOURCE LOADS 
 
      IF(INPSOPT.GT.1.AND.TIME.GE.NXNPST)   
     .   CALL RCA10(BNPS,NWK,NONPS,NXNPST,23,SCALNPS)

C        FALL-LINE LOADS 
 
      IF(IFLOPT.GT.1.AND.TIME.GE.NXFLT)   
     .   CALL RCA10(BFL,NWK,NOFL,NXFLT,24,SCALFL)

C        ATMOSPHERIC LOADS 
 
      IF(IATMOPT.GT.1.AND.TIME.GE.NXATMT)   
     .   CALL RCA10(BATM,1,NOATM,NXATMT,25,SCALATM)

C        NEXT BOUNDARY CONDITIONS 

      IF(IBCOPT.GT.1.AND.TIME.GT.NXBCT) CALL RCA11 

C        NEXT TRANSPORT FIELDS

      IF(TIME.GE.HYDBRK(ITIMHYD))  THEN
         CALL RCA03A
         CALL RCASPLT1
         ITIMHYD = ITIMHYD+1
         DO 580 ISEG=1,NSEGSPLT
           IR = ISEGSPLT(ISEG,1)
           IC = ISEGSPLT(ISEG,2)
           IL = ISEGSPLT(ISEG,3)
           RXSPLT(ISEG,1) = RX(IR,IC,IL)
           RXSPLT(ISEG,2) = RX(IR+1,IC,IL)
           RYSPLT(ISEG,1) = RY(IR,IC,IL)
           RYSPLT(ISEG,2) = RY(IR,IC+1,IL)
  580    CONTINUE

         DO 585 ISEG=1,NSEGSPLT
           IR = ISEGSPLT(ISEG,1)
           IC = ISEGSPLT(ISEG,2)
           IL = ISEGSPLT(ISEG,3)
           RX(IR,IC,IL) = 0.0
           RX(IR+1,IC,IL) = 0.0
           RY(IR,IC,IL) = 0.0
           RY(IR,IC+1,IL) = 0.0
  585    CONTINUE

      ENDIF


C        CHECK FOR END OF SIMULATION...
C           IF NOT GO BACK AND TAKE NEXT INTEGRATION STEP

      IF(TIME.LE.TEND)   GO TO 40 

      ITRAK = ITRAK+1 
      IF(ITRAK.LE.NSTEP)  THEN
         DT=STEP(ITRAK)
         TEND = TBRK(ITRAK) 
         IF(DT.EQ.0.0)   THEN
            CALL RCAMESS(6,DT)
            CALL EXIT
         ENDIF
      ELSE
         TEND = 0.0
      ENDIF 

      DTSTEP = DT 
      DT = SCALT*DT 
      IF(TEND.GT.0.)   GO TO 40 

C        FINISHED...CALL FOR FINAL DUMPS

      IDISK = 1 
      CALL TUNER
      RETURN


C         STABILITY CRITERIA VIOLATED...ABEND 

  600 CALL RCAMESS(1,CKMAX) 
      WRITE(OUT,9000)  BVOLN(IR,IC,IL),DIAG(IR,IC,IL)
 9000 FORMAT(10X,'VOLUME =',E13.4,'  ,DIAGONAL =',E13.4)
      IREC = IREC+1 
      IDISK = 1 
      CALL TUNER
      RETURN
      END 
